package testkinect;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import utildll.*;

public class TestKINECT101 extends JFrame implements Runnable, ActionListener {
	Wrp_KINECT wk = new Wrp_KINECT();
	Wrp_INuiSensor wins = null;
	Wrp_INuiCoordinateMapper wmap = null;
	Wrp_Kernel32 wkrnl = new Wrp_Kernel32();
	Wrp_JInvoker wjinv = new Wrp_JInvoker();
	long[] kinect = {0};
	long[] hColor = {0};
	long[] hDepth = {0};
	long[] mapper = {0};
	long hColorEvent = 0;
	long hDepthEvent = 0;
	long hSkeletonEvent = 0;
	long[] hEvents;
	int[] width = {0};
	int[] height = {0};
	int[] color;
	int[] depth; //NUI_DEPTH_IMAGE_PIXEL {USHORT playerIndex; USHORT depth;}
	int[] colorPoint; // NUI_COLOR_IMAGE_POINT {LONG x; LONG y;}
	
	final int IMG_WIDTH = 640;
	final int IMG_HEIGHT = 480;
	final int BORDER_WIDTH = 4;
	final int TITLE_HEIGHT = 30;
	final int PANEL_HEIGHT = 40;
	JButton btnUp, btnDown, btnExit;
	boolean blUp = false, blDown = false, blExit = false; 
	JPanel pnl;
	ImageCanvas imgcvs;
	BufferedImage bfimgOff = new BufferedImage(IMG_WIDTH, IMG_HEIGHT, BufferedImage.TYPE_INT_RGB);
	Graphics grphOff = bfimgOff.getGraphics();
	boolean blPaint = false;
	
	public static void main(String[] args) {
		TestKINECT101 testkinect = new TestKINECT101();
	}
	
	TestKINECT101() {
		this.setTitle("KINECT_TEST101");
		this.setSize(IMG_WIDTH + BORDER_WIDTH * 2, IMG_HEIGHT + TITLE_HEIGHT + PANEL_HEIGHT + BORDER_WIDTH);
		this.setLocationRelativeTo(null);
		this.setLayout(null);
		this.setResizable(false);
		
		imgcvs = new ImageCanvas();
		imgcvs.setBounds(0, 0, IMG_WIDTH, IMG_HEIGHT);
		getContentPane().add(imgcvs);
		
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT, 10, 5));
		pnl.setBounds(0, IMG_HEIGHT, IMG_WIDTH, PANEL_HEIGHT);
		
		btnUp = new JButton("   Up   ");
		btnUp.addActionListener(this);
		pnl.add(btnUp);
		
		btnDown = new JButton("  Down  ");
		btnDown.addActionListener(this);
		pnl.add(btnDown);
		
		btnExit = new JButton("  Exit  ");
		btnExit.addActionListener(this);
		pnl.add(btnExit);
		
		getContentPane().add(pnl);
		
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent ev) {
				System.exit(0);
			}
		});

		this.setVisible(true);
		
		Thread thread = new Thread(this);
		thread.start();
	}
	
	public void actionPerformed(ActionEvent e) {
		JButton btn = (JButton)e.getSource();
		if (btn == btnUp) {
			blUp = true;
		}
		else if (btn == btnDown) {
			blDown = true;
		}
		else if (btn == btnExit) {
			blExit = true;
		}
	}

	class ImageCanvas extends Canvas {
		public void paint(Graphics g){
			if (blPaint == true) {
				g.drawImage(bfimgOff, 0, 0, this);
				blPaint = false;
			}
		}
		
		public void update(Graphics g){
			paint(g);
		}
	}

	public void run() {
		try {
			initialize();
			drawcvs();
		}
		catch (Exception_KINECT e) {
			System.out.println("***** Exception_KINECT: " + e.getMessage());
		}
		catch (Exception_Win64 e) {
			System.out.println("***** Exception_Win64: " + e.getMessage());
		}
		catch (Exception_JInvoker e) {
			System.out.println("***** Exception_JInvoker: " + e.getMessage());
		}
		finally {
			System.out.println("finally start ");
			try {
				terminate();
			}
			catch (Exception_KINECT e) {
				System.out.println("***** Exception_KINECT: " + e.getMessage());
			}
			catch (Exception_Win64 e) {
				System.out.println("***** Exception_Win64: " + e.getMessage());
			}
			System.out.println("finally end ");
		}
		System.exit(0);
	}
	
	void initialize() throws Exception_KINECT, Exception_Win64 {
		// create Kinect instance
		int[] count = {0};
		wk.NuiGetSensorCount(count);
		System.out.println("sensor count: " + Integer.toString(count[0]));
		
		wk.NuiCreateSensorByIndex(0, kinect);
		System.out.println("instance#0: " + Long.toHexString(kinect[0]));
		
		wins = new Wrp_INuiSensor(kinect[0]);
		int sts = wins.NuiStatus();
		System.out.println("status: " + Integer.toHexString(sts));
		
		// initialize
		wins.NuiInitialize(H_NuiApi.NUI_INITIALIZE_FLAG_USES_COLOR
				| H_NuiApi.NUI_INITIALIZE_FLAG_USES_DEPTH_AND_PLAYER_INDEX
				| H_NuiApi.NUI_INITIALIZE_FLAG_USES_SKELETON);
		
		// open color stream
		hColorEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiImageStreamOpen(H_NuiImageCamera.NUI_IMAGE_TYPE_COLOR,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, 0, 2, hColorEvent, hColor);
		System.out.println("color stream: " + Long.toHexString(hColor[0]));
		
		// open depth stream
		hDepthEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiImageStreamOpen(H_NuiImageCamera.NUI_IMAGE_TYPE_DEPTH_AND_PLAYER_INDEX,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, 0, 2, hDepthEvent, hDepth);
		System.out.println("depth stream: " + Long.toHexString(hDepth[0]));

		// near mode
		//wins.NuiImageStreamSetImageFrameFlags(hDepth[0],
		//		H_NuiImageCamera.NUI_IMAGE_STREAM_FLAG_ENABLE_NEAR_MODE);
		
		// enable skeleton tracking
		hSkeletonEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiSkeletonTrackingEnable(hSkeletonEvent, 0);
		
		// get width and height
		wk.NuiImageResolutionToSize(H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, width, height);
		System.out.println("camera size: " + Integer.toString(width[0]) + "x"
				+ Integer.toString(height[0]));
		
		color = new int[width[0] * height[0]];
		depth = new int[width[0] * height[0]];
		colorPoint = new int[width[0] * height[0] * 2]; // x, y
		
		// get coodinate mapper
		wins.NuiGetCoordinateMapper(mapper);
		System.out.println("CoordinateMapper: " + Long.toHexString(mapper[0]));
		wmap = new Wrp_INuiCoordinateMapper(mapper[0]);
		
		hEvents = new long[]{hColorEvent, hDepthEvent, hSkeletonEvent};
	}
	
	void drawcvs() throws Exception_KINECT, Exception_Win64, Exception_JInvoker {
		
		for (;;) {
			
			setColorImage();
			drawSkeleton();
			
			blPaint = true;
			imgcvs.repaint();
			
			if (blUp) {
				setAngle(+5);
			}
			if(blDown) {	
				setAngle(-5);
			}
			if (blExit) {
				break;
			}
		}
	}

	void setColorImage() throws Exception_KINECT, Exception_Win64, Exception_JInvoker {
		wkrnl.ResetEvent(hColorEvent);
		wkrnl.ResetEvent(hDepthEvent);
		wkrnl.ResetEvent(hSkeletonEvent);
		wkrnl.WaitForMultipleObjects(hEvents.length, hEvents, true, H_WinBase.INFINITE);

		// get color frame
		Struct_NUI_IMAGE_FRAME colorFrame = new Struct_NUI_IMAGE_FRAME();
		wins.NuiImageStreamGetNextFrame(hColor[0], 0, colorFrame);
		
		Wrp_INuiFrameTexture winftColor = new Wrp_INuiFrameTexture(colorFrame.pFrameTexture);
		
		Struct_NUI_LOCKED_RECT colorRect = new Struct_NUI_LOCKED_RECT();
		winftColor.LockRect(0, colorRect, null, 0);

		System.out.println("color data adrs: " + Long.toHexString(colorRect.pBits));
		
		// copy color data
		wjinv.movePtrToIntArray(color, colorRect.pBits);
		
		winftColor.UnlockRect(0);
		wins.NuiImageStreamReleaseFrame(hColor[0], colorFrame);
		
		// get depth frame
		Struct_NUI_IMAGE_FRAME depthFrame = new Struct_NUI_IMAGE_FRAME();
		wins.NuiImageStreamGetNextFrame(hDepth[0], 0, depthFrame);
		
		boolean[] pNearMode = {false};
		long[] ppFrameTexture = {0};
		wins.NuiImageFrameGetDepthImagePixelFrameTexture(hDepth[0], depthFrame, pNearMode,
				ppFrameTexture);
		
		Wrp_INuiFrameTexture winftDepth = new Wrp_INuiFrameTexture(ppFrameTexture[0]);
		
		Struct_NUI_LOCKED_RECT depthRect = new Struct_NUI_LOCKED_RECT();
		winftDepth.LockRect(0, depthRect, null, 0);
		
		System.out.println("depth data adrs: " + Long.toHexString(depthRect.pBits));
		
		// copy depth data
		wjinv.movePtrToIntArray(depth, depthRect.pBits);

		wmap.MapDepthFrameToColorFrame(H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480,
				depth.length, depthRect.pBits, H_NuiImageCamera.NUI_IMAGE_TYPE_COLOR,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, color.length, colorPoint);
		
		// if beyond 2m, paint white except player
		for (int i = 0; i < depth.length; i++) {
			int distance = (depth[i] >> 16) & 0xffff;
			int player = depth[i] & 0xffff;
			
			int colorX = colorPoint[i * 2];
			int colorY = colorPoint[i * 2 + 1];

			if (colorX >= 0 && colorX < width[0] && colorY >= 0 && colorY < height[0]) {
				int index = (colorY * width[0]) + colorX;
				if (player > 0) {
					//color[index] = 0x000000ff; // blue
				}
				else if (distance >= 2000) { // beyond 2m
					color[index] = 0x00ffffff; // white
				}
			}
		}
		
		winftDepth.UnlockRect(0);
		wins.NuiImageStreamReleaseFrame(hDepth[0], depthFrame);
		
		// set color image
		bfimgOff.setRGB(0, 0, IMG_WIDTH, IMG_HEIGHT, color, 0, IMG_WIDTH);
	}
	
	void drawSkeleton() throws Exception_KINECT {
		// get skeleton frame
		Struct_NUI_SKELETON_FRAME skeletonFrame = new Struct_NUI_SKELETON_FRAME();
		int hr = wins.NuiSkeletonGetNextFrame(0, skeletonFrame);
	
		// draw skeleton
		if (H_WinError.SUCCEEDED(hr)) {
			for (int i = 0; i < H_NuiSkeleton.NUI_SKELETON_COUNT; i++) {
				Struct_NUI_SKELETON_DATA skeletonData = skeletonFrame.SkeletonData[i];
				System.out.println("SkeletonData[" + Integer.toString(i) + "].eTrackingState: "
							+ Integer.toString(skeletonData.eTrackingState));
	
				if (skeletonData.eTrackingState == H_NuiSkeleton.NUI_SKELETON_TRACKED) {
					Struct_POINT[] sp = new Struct_POINT[H_NuiSkeleton.NUI_SKELETON_POSITION_COUNT];
					for (int j = 0; j < H_NuiSkeleton.NUI_SKELETON_POSITION_COUNT; j++) {
						if (skeletonData.eSkeletonPositionTrackingState[j]
								!= H_NuiSkeleton.NUI_SKELETON_POSITION_NOT_TRACKED) {
							sp[j] = drawJoint(skeletonData.SkeletonPositions[j]);
						}
					}
					drawLine(sp);
				}
				else if (skeletonData.eTrackingState == H_NuiSkeleton.NUI_SKELETON_POSITION_ONLY) {
					drawJoint(skeletonData.Position);
				}
			}
		}
	}

	Struct_POINT drawJoint(Struct_Vector4 position) throws Exception_KINECT {
		int[] pColorPoint = {0, 0};
		wmap.MapSkeletonPointToColorPoint(position, H_NuiImageCamera.NUI_IMAGE_TYPE_COLOR,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, pColorPoint);
		
		//System.out.println("MapSkeletonPointToColorPoint: " + Integer.toString(pColorPoint[0])
		//		+ ", " + Integer.toString(pColorPoint[1]));
		
		grphOff.setColor(Color.green);
		grphOff.drawOval(pColorPoint[0], pColorPoint[1], 5, 5);
		
		return new Struct_POINT(pColorPoint[0], pColorPoint[1]);
	}
	
	void drawLine(Struct_POINT[] sp) {
		for (int i = 0; i < H_NuiSkeleton.NUI_SKELETON_POSITION_COUNT; i++) {
			if (sp[i] == null) return;
		}
		
		int[] pointx = new int[5];
		int[] pointy = new int[5];
		grphOff.setColor(Color.green);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SPINE].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SPINE].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].y;
		grphOff.drawPolyline(pointx, pointy, 4);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_LEFT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_LEFT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_LEFT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_LEFT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_LEFT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_LEFT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_LEFT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_LEFT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_RIGHT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_RIGHT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_RIGHT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_RIGHT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_RIGHT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_RIGHT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_RIGHT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_RIGHT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_LEFT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_LEFT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_LEFT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_LEFT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_LEFT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_LEFT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_LEFT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_LEFT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_RIGHT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_RIGHT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_RIGHT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_RIGHT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_RIGHT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_RIGHT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_RIGHT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_RIGHT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
	}
	
	void setAngle(int angl) throws Exception_KINECT {
		int[] anglCur = {0};
		int anglSet = 0;
		
		wins.NuiCameraElevationGetAngle(anglCur);
		System.out.println("anglCur: " + Integer.toString(anglCur[0]));
		
		if (angl > 0) {
			anglSet = (anglCur[0] + angl < H_NuiImageCamera.NUI_CAMERA_ELEVATION_MAXIMUM)
					? anglCur[0] + angl : H_NuiImageCamera.NUI_CAMERA_ELEVATION_MAXIMUM;
		}
		else if (angl < 0) {
			anglSet = (anglCur[0] + angl > H_NuiImageCamera.NUI_CAMERA_ELEVATION_MINIMUM)
					? anglCur[0] + angl : H_NuiImageCamera.NUI_CAMERA_ELEVATION_MINIMUM;
		}
		else {
			anglSet = 0;
		}
		wins.NuiCameraElevationSetAngle(anglSet);
		blUp = false;
		blDown = false;
	}
	
	void terminate() throws Exception_KINECT, Exception_Win64 {
		
		if (kinect[0] != 0) {
			if (wmap != null) {
				wmap.Release();
			}
			if (wins != null) {
				setAngle(0);
				wins.NuiSkeletonTrackingDisable();
				wins.NuiShutdown();
				wins.Release();
			}
		}
		if (wkrnl != null) {
			if (hColorEvent != 0) wkrnl.CloseHandle(hColorEvent);
			if (hDepthEvent != 0) wkrnl.CloseHandle(hDepthEvent);
			if (hSkeletonEvent != 0) wkrnl.CloseHandle(hSkeletonEvent);
		}
		if (grphOff != null) grphOff.dispose();
	}
	
}
