package testkinect;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import utildll.*;

public class TestKINECT102 extends JFrame implements Runnable, ActionListener {
	Wrp_KINECT wk = new Wrp_KINECT();
	Wrp_INuiSensor wins = null;
	Wrp_INuiCoordinateMapper wmap = null;
	Wrp_Kernel32 wkrnl = new Wrp_Kernel32();
	Wrp_JInvoker wjinv = new Wrp_JInvoker();
	long[] kinect = {0};
	long[] hColor = {0};
	long[] hDepth = {0};
	long[] mapper = {0};
	long hColorEvent = 0;
	long hDepthEvent = 0;
	long hSkeletonEvent = 0;
	long[] hEvents;
	int[] width = {0};
	int[] height = {0};
	int[] color;
	short[] depth; // depth:13bit, player index:3bit
	int[] colorPoint; // NUI_COLOR_IMAGE_POINT {LONG x; LONG y;}
	
	// face tracking
	Wrp_FaceTracker wft = new Wrp_FaceTracker();
	Wrp_IFTFaceTracker wiftft = null;
	Wrp_IFTResult wiftr = null;
	Wrp_IFTImage wiftiColor = null, wiftiDepth = null;
	long faceTracker = 0, imageColor = 0, imageDepth = 0;
	long[] result = {0};
	Struct_FT_CAMERA_CONFIG sftccColor, sftccDepth;
	Struct_FT_SENSOR_DATA sftsd;
	Struct_FT_WEIGHTED_RECT[] detectFaces = new Struct_FT_WEIGHTED_RECT[6];
	int[] detectFaceCount = {0};
	Struct_RECT rectFace = new Struct_RECT();
	Struct_FT_VECTOR3D[] hintPoints = null;
	Struct_FT_VECTOR2D[] points = null;
	int[] pointCount = {0};
	boolean isFaceTracked = false;
	
	final int IMG_WIDTH = 640;
	final int IMG_HEIGHT = 480;
	final int BORDER_WIDTH = 4;
	final int TITLE_HEIGHT = 30;
	final int PANEL_HEIGHT = 40;
	JButton btnUp, btnDown, btnExit;
	boolean blUp = false, blDown = false, blExit = false; 
	JPanel pnl;
	ImageCanvas imgcvs;
	BufferedImage bfimgOff = new BufferedImage(IMG_WIDTH, IMG_HEIGHT, BufferedImage.TYPE_INT_RGB);
	Graphics grphOff = bfimgOff.getGraphics();
	boolean blPaint = false;

	public static void main(String[] args) {
		TestKINECT102 testkinect = new TestKINECT102();
	}
	
	TestKINECT102() {
		this.setTitle("KINECT_TEST102");
		this.setSize(IMG_WIDTH + BORDER_WIDTH * 2, IMG_HEIGHT + TITLE_HEIGHT + PANEL_HEIGHT + BORDER_WIDTH);
		this.setLocationRelativeTo(null);
		this.setLayout(null);
		this.setResizable(false);
		
		imgcvs = new ImageCanvas();
		imgcvs.setBounds(0, 0, IMG_WIDTH, IMG_HEIGHT);
		getContentPane().add(imgcvs);
		
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT, 10, 5));
		pnl.setBounds(0, IMG_HEIGHT, IMG_WIDTH, PANEL_HEIGHT);
		
		btnUp = new JButton("   Up   ");
		btnUp.addActionListener(this);
		pnl.add(btnUp);
		
		btnDown = new JButton("  Down  ");
		btnDown.addActionListener(this);
		pnl.add(btnDown);
		
		btnExit = new JButton("  Exit  ");
		btnExit.addActionListener(this);
		pnl.add(btnExit);
		
		getContentPane().add(pnl);
		
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent ev) {
				System.exit(0);
			}
		});

		this.setVisible(true);
		
		Thread thread = new Thread(this);
		thread.start();
	}
	
	public void actionPerformed(ActionEvent e) {
		JButton btn = (JButton)e.getSource();
		if (btn == btnUp) {
			blUp = true;
		}
		else if (btn == btnDown) {
			blDown = true;
		}
		else if (btn == btnExit) {
			blExit = true;
		}
	}

	class ImageCanvas extends Canvas {
		public void paint(Graphics g){
			if (blPaint == true) {
				g.drawImage(bfimgOff, 0, 0, this);
				blPaint = false;
			}
		}
		
		public void update(Graphics g){
			paint(g);
		}
	}

	public void run() {
		try {
			initialize();
			drawcvs();
		}
		catch (Exception_KINECT e) {
			System.out.println("***** Exception_KINECT: " + e.getMessage());
		}
		catch (Exception_Win64 e) {
			System.out.println("***** Exception_Win64: " + e.getMessage());
		}
		catch (Exception_JInvoker e) {
			System.out.println("***** Exception_JInvoker: " + e.getMessage());
		}
		finally {
			System.out.println("finally start ");
			try {
				terminate();
			}
			catch (Exception_KINECT e) {
				System.out.println("***** Exception_KINECT: " + e.getMessage());
			}
			catch (Exception_Win64 e) {
				System.out.println("***** Exception_Win64: " + e.getMessage());
			}
			System.out.println("finally end ");
		}
		System.exit(0);
	}
	
	void initialize() throws Exception_KINECT, Exception_Win64 {
		// create Kinect instance
		int[] count = {0};
		wk.NuiGetSensorCount(count);
		System.out.println("sensor count: " + Integer.toString(count[0]));
		
		wk.NuiCreateSensorByIndex(0, kinect);
		System.out.println("instance#0: " + Long.toHexString(kinect[0]));
		
		wins = new Wrp_INuiSensor(kinect[0]);
		int sts = wins.NuiStatus();
		System.out.println("status: " + Integer.toHexString(sts));
		
		// initialize
		wins.NuiInitialize(H_NuiApi.NUI_INITIALIZE_FLAG_USES_COLOR
				| H_NuiApi.NUI_INITIALIZE_FLAG_USES_DEPTH_AND_PLAYER_INDEX
				| H_NuiApi.NUI_INITIALIZE_FLAG_USES_SKELETON);
		
		// open color stream
		hColorEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiImageStreamOpen(H_NuiImageCamera.NUI_IMAGE_TYPE_COLOR,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, 0, 2, hColorEvent, hColor);
		System.out.println("color stream: " + Long.toHexString(hColor[0]));
		
		// open depth stream
		hDepthEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiImageStreamOpen(H_NuiImageCamera.NUI_IMAGE_TYPE_DEPTH_AND_PLAYER_INDEX,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, 0, 2, hDepthEvent, hDepth);
		System.out.println("depth stream: " + Long.toHexString(hDepth[0]));

		// near mode
		//wins.NuiImageStreamSetImageFrameFlags(hDepth[0],
		//		H_NuiImageCamera.NUI_IMAGE_STREAM_FLAG_ENABLE_NEAR_MODE);
		
		// enable skeleton tracking
		hSkeletonEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiSkeletonTrackingEnable(hSkeletonEvent, 0);
		
		// get width and height
		wk.NuiImageResolutionToSize(H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, width, height);
		System.out.println("camera size: " + Integer.toString(width[0]) + "x"
				+ Integer.toString(height[0]));
		
		color = new int[width[0] * height[0]];
		depth = new short[width[0] * height[0]]; // depth:13bit, player index:3bit
		colorPoint = new int[width[0] * height[0] * 2]; // NUI_COLOR_IMAGE_POINT {LONG x; LONG y;}
		
		// get coodinate mapper
		wins.NuiGetCoordinateMapper(mapper);
		System.out.println("CoordinateMapper: " + Long.toHexString(mapper[0]));
		wmap = new Wrp_INuiCoordinateMapper(mapper[0]);
		
		hEvents = new long[]{hColorEvent, hDepthEvent, hSkeletonEvent};
		
		//create FaceTracker instance
		faceTracker = wft.FTCreateFaceTracker();
		wiftft = new Wrp_IFTFaceTracker(faceTracker);
		
		sftccColor = new Struct_FT_CAMERA_CONFIG(width[0], height[0],
				H_NuiImageCamera.NUI_CAMERA_COLOR_NOMINAL_FOCAL_LENGTH_IN_PIXELS * (width[0] / 640.0f));

		sftccDepth = new Struct_FT_CAMERA_CONFIG(width[0], height[0],
				H_NuiImageCamera.NUI_CAMERA_DEPTH_NOMINAL_FOCAL_LENGTH_IN_PIXELS * (width[0] / 320.0f));
		
		//initialize FaceTracker
		wiftft.Initialize(sftccColor, sftccDepth, 0, null);
		
		//create FaceTracker result instance
		wiftft.CreateFTResult(result);
		wiftr = new Wrp_IFTResult(result[0]);
		
		imageColor = wft.FTCreateImage();
		wiftiColor = new Wrp_IFTImage(imageColor);
		
		imageDepth = wft.FTCreateImage();
		wiftiDepth = new Wrp_IFTImage(imageDepth);
		
		wiftiColor.Allocate(width[0], height[0], H_FaceTracKLib.FTIMAGEFORMAT_UINT8_B8G8R8X8);
		wiftiDepth.Allocate(width[0], height[0], H_FaceTracKLib.FTIMAGEFORMAT_UINT16_D13P3);
		
		//initialize FT_SENSOR_DATA structure
		sftsd = new Struct_FT_SENSOR_DATA(imageColor, imageDepth, 1.0f, new Struct_POINT(0, 0));
		
		//initialize FT_WEIGHTED_RECT structure array
		for (int i = 0; i < detectFaces.length; i++) detectFaces[i] = new Struct_FT_WEIGHTED_RECT();
		
	}
	
	void drawcvs() throws Exception_KINECT, Exception_Win64, Exception_JInvoker {
		
		for (;;) {
			
			setColorImage();
			drawSkeleton();
			//drawDetectFaceRect();
			getFacePoints();
			drawFacePoints();
			
			blPaint = true;
			imgcvs.repaint();
			
			if (blUp) {
				setAngle(+5);
			}
			if(blDown) {	
				setAngle(-5);
			}
			if (blExit) {
				break;
			}
		}
	}
	
	
	void setColorImage() throws Exception_KINECT, Exception_Win64, Exception_JInvoker {
		wkrnl.ResetEvent(hColorEvent);
		wkrnl.ResetEvent(hDepthEvent);
		wkrnl.ResetEvent(hSkeletonEvent);
		wkrnl.WaitForMultipleObjects(hEvents.length, hEvents, true, H_WinBase.INFINITE);

		// get color frame
		Struct_NUI_IMAGE_FRAME colorFrame = new Struct_NUI_IMAGE_FRAME();
		wins.NuiImageStreamGetNextFrame(hColor[0], 0, colorFrame);
		
		Wrp_INuiFrameTexture winftColor = new Wrp_INuiFrameTexture(colorFrame.pFrameTexture);
		
		Struct_NUI_LOCKED_RECT colorRect = new Struct_NUI_LOCKED_RECT();
		winftColor.LockRect(0, colorRect, null, 0);

		System.out.println("color data adrs: " + Long.toHexString(colorRect.pBits));
		
		// copy color data
		wjinv.movePtrToIntArray(color, colorRect.pBits); //for Canvas
		wkrnl.RtlMoveMemory(wiftiColor.GetBuffer(), colorRect.pBits, colorRect.size); //for FaceTracker
		
		winftColor.UnlockRect(0);
		wins.NuiImageStreamReleaseFrame(hColor[0], colorFrame);
		
		// get depth frame
		Struct_NUI_IMAGE_FRAME depthFrame = new Struct_NUI_IMAGE_FRAME();
		wins.NuiImageStreamGetNextFrame(hDepth[0], 0, depthFrame);
		
		Wrp_INuiFrameTexture winftDepth = new Wrp_INuiFrameTexture(depthFrame.pFrameTexture);
		
		Struct_NUI_LOCKED_RECT depthRect = new Struct_NUI_LOCKED_RECT();
		winftDepth.LockRect(0, depthRect, null, 0);

		System.out.println("depth data adrs: " + Long.toHexString(depthRect.pBits));
		
		// copy depth data
		wkrnl.RtlMoveMemory(wiftiDepth.GetBuffer(), depthRect.pBits, depthRect.size); //for FaceTracker

		winftDepth.UnlockRect(0);
		wins.NuiImageStreamReleaseFrame(hDepth[0], depthFrame);
		
		// set color image
		bfimgOff.setRGB(0, 0, IMG_WIDTH, IMG_HEIGHT, color, 0, IMG_WIDTH);
	}
	
	void drawSkeleton() throws Exception_KINECT {
		hintPoints = null; // for FaceTracker

		// get skeleton frame
		Struct_NUI_SKELETON_FRAME skeletonFrame = new Struct_NUI_SKELETON_FRAME();
		int hr = wins.NuiSkeletonGetNextFrame(0, skeletonFrame);
	
		// draw skeleton
		if (H_WinError.SUCCEEDED(hr)) {
			for (int i = 0; i < H_NuiSkeleton.NUI_SKELETON_COUNT; i++) {
				Struct_NUI_SKELETON_DATA skeletonData = skeletonFrame.SkeletonData[i];
				System.out.println("SkeletonData[" + Integer.toString(i) + "].eTrackingState: "
							+ Integer.toString(skeletonData.eTrackingState));
	
				if (skeletonData.eTrackingState == H_NuiSkeleton.NUI_SKELETON_TRACKED) {
					Struct_POINT[] sp = new Struct_POINT[H_NuiSkeleton.NUI_SKELETON_POSITION_COUNT];
					for (int j = 0; j < H_NuiSkeleton.NUI_SKELETON_POSITION_COUNT; j++) {
						if (skeletonData.eSkeletonPositionTrackingState[j]
								!= H_NuiSkeleton.NUI_SKELETON_POSITION_NOT_TRACKED) {
							sp[j] = drawJoint(skeletonData.SkeletonPositions[j]);
						}
					}
					drawLine(sp);
					
					// get hint positions for FaceTracker
					if (skeletonData.eSkeletonPositionTrackingState[
					        H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD]
							!= H_NuiSkeleton.NUI_SKELETON_POSITION_NOT_TRACKED
							&& skeletonData.eSkeletonPositionTrackingState[
							H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER]
							!= H_NuiSkeleton.NUI_SKELETON_POSITION_NOT_TRACKED) {
						
						hintPoints = new Struct_FT_VECTOR3D[] {
								new Struct_FT_VECTOR3D(), new Struct_FT_VECTOR3D()};
						hintPoints[0].x = skeletonData.SkeletonPositions[
						        H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD].x;
						hintPoints[0].y = skeletonData.SkeletonPositions[
						        H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD].y;
						hintPoints[0].z = skeletonData.SkeletonPositions[
						        H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD].z;
						hintPoints[1].x = skeletonData.SkeletonPositions[
						        H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].x;
						hintPoints[1].y = skeletonData.SkeletonPositions[
						        H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].y;
						hintPoints[1].z = skeletonData.SkeletonPositions[
						        H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].z;
					}
				}
				else if (skeletonData.eTrackingState == H_NuiSkeleton.NUI_SKELETON_POSITION_ONLY) {
					drawJoint(skeletonData.Position);
				}
			}
		}
	}

	Struct_POINT drawJoint(Struct_Vector4 position) throws Exception_KINECT {
		int[] pColorPoint = {0, 0};
		wmap.MapSkeletonPointToColorPoint(position, H_NuiImageCamera.NUI_IMAGE_TYPE_COLOR,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, pColorPoint);
		
		//System.out.println("MapSkeletonPointToColorPoint: " + Integer.toString(pColorPoint[0])
		//		+ ", " + Integer.toString(pColorPoint[1]));
		
		grphOff.setColor(Color.green);
		grphOff.drawOval(pColorPoint[0], pColorPoint[1], 5, 5);
		
		return new Struct_POINT(pColorPoint[0], pColorPoint[1]);
	}
	
	void drawLine(Struct_POINT[] sp) {
		for (int i = 0; i < H_NuiSkeleton.NUI_SKELETON_POSITION_COUNT; i++) {
			if (sp[i] == null) return;
		}
		
		int[] pointx = new int[5];
		int[] pointy = new int[5];
		grphOff.setColor(Color.green);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HEAD].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SPINE].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SPINE].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].y;
		grphOff.drawPolyline(pointx, pointy, 4);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_LEFT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_LEFT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_LEFT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_LEFT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_LEFT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_LEFT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_LEFT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_LEFT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_RIGHT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_SHOULDER_RIGHT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_RIGHT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ELBOW_RIGHT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_RIGHT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_WRIST_RIGHT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_RIGHT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HAND_RIGHT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_LEFT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_LEFT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_LEFT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_LEFT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_LEFT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_LEFT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_LEFT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_LEFT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
		
		pointx[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].x;
		pointy[0] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_CENTER].y;
		pointx[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_RIGHT].x;
		pointy[1] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_HIP_RIGHT].y;
		pointx[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_RIGHT].x;
		pointy[2] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_KNEE_RIGHT].y;
		pointx[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_RIGHT].x;
		pointy[3] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_ANKLE_RIGHT].y;
		pointx[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_RIGHT].x;
		pointy[4] = sp[H_NuiSkeleton.NUI_SKELETON_POSITION_FOOT_RIGHT].y;
		grphOff.drawPolyline(pointx, pointy, 5);
	}
	
	void getFacePoints() throws Exception_KINECT {
		// get face points
		int hr;
		if (!isFaceTracked) {
			hr = wiftft.StartTracking(sftsd, null, hintPoints, result[0]);
			System.out.println("StartTracking hr: " + Integer.toHexString(hr));
		}
		else {
			hr = wiftft.ContinueTracking(sftsd, hintPoints, result[0]);
			System.out.println("ContinueTracking hr: " + Integer.toHexString(hr));
		}
		
		int hrsts = wiftr.GetStatus();
		System.out.println("GetStatus hrsts: " + Integer.toHexString(hrsts));
		
		if (H_WinError.SUCCEEDED(hr) && H_WinError.SUCCEEDED(hrsts)) {
			isFaceTracked = true;
			
			wiftr.GetFaceRect(rectFace);
			System.out.println("GetFaceRect rectFace: " + Integer.toString(rectFace.left)
					+ " " + Integer.toString(rectFace.right)
					+ " " + Integer.toString(rectFace.top)
					+ " " + Integer.toString(rectFace.bottom));
			
			points = wiftr.Get2DShapePoints(pointCount);
			System.out.println("Get2DShapePoints pointCount: " + Integer.toString(pointCount[0]));
		}
		else {
			isFaceTracked = false;
		}
	}

	void drawDetectFaceRect() throws Exception_KINECT {
		// detect faces
		detectFaceCount[0] = 20 * detectFaces.length; //in:byte size, out:face count
		int hrdf = wiftft.DetectFaces(sftsd, null, detectFaces, detectFaceCount);
		
		System.out.println("DetectFaces detectFaceCount: " + Integer.toString(detectFaceCount[0]));
		for (int i = 0; i < detectFaceCount[0]; i++) {
			System.out.println("DetectFaces#" + Integer.toString(i)
					+ " Weight: " + Float.toString(detectFaces[i].Weight)
					+ " Rect: " + Integer.toString(detectFaces[i].Rect.left)
					+ " " + Integer.toString(detectFaces[i].Rect.right)
					+ " " + Integer.toString(detectFaces[i].Rect.top)
					+ " " + Integer.toString(detectFaces[i].Rect.bottom));
		}
		
		grphOff.setColor(Color.cyan);
		for (int i = 0; i < detectFaceCount[0]; i++) {
			grphOff.drawRect(detectFaces[i].Rect.left, detectFaces[i].Rect.top,
					detectFaces[i].Rect.right - detectFaces[i].Rect.left + 1,
					detectFaces[i].Rect.bottom - detectFaces[i].Rect.top + 1);
		}
	}
	
	void drawFacePoints() {
		if (isFaceTracked) {
			grphOff.setColor(Color.magenta);
			
			grphOff.drawRect(rectFace.left, rectFace.top, rectFace.right - rectFace.left + 1,
					rectFace.bottom - rectFace.top + 1);
	
			grphOff.setColor(Color.yellow);
			if (points != null && pointCount[0] > 0) {
				int[] pointx = new int[19];
				int[] pointy = new int[19];
				int start, len;
				//
				start = 0; len = 8;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolygon(pointx, pointy, len);
				
				//E
				start = 8; len = 8;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolygon(pointx, pointy, len);
				
				//
				start = 16; len = 10;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolygon(pointx, pointy, len);
				
				//E
				start = 26; len = 10;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolygon(pointx, pointy, len);
				
				//@
				start = 36; len = 12;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolyline(pointx, pointy, len);
				
				//@O
				start = 48; len = 12;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolygon(pointx, pointy, len);
				
				//@
				start = 60; len = 8;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolygon(pointx, pointy, len);
				
				//{
				start = 68; len = 19;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolyline(pointx, pointy, len);
				
				//ڒSA@S
				for (int i = 87; i <= 89; i++) {
					grphOff.drawOval((int)points[i].x, (int)points[i].y, 2, 2);
				}

				//̏
				start = 90; len = 5;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolyline(pointx, pointy, len);

				//Ȅ
				start = 95; len = 5;
				for (int i = 0; i < len; i++) { 
					pointx[i] = (int)points[start + i].x;
					pointy[i] = (int)points[start + i].y;
				}
				grphOff.drawPolyline(pointx, pointy, len);
			}
		}
	}

	void setAngle(int angl) throws Exception_KINECT {
		int[] anglCur = {0};
		int anglSet = 0;
		
		wins.NuiCameraElevationGetAngle(anglCur);
		System.out.println("anglCur: " + Integer.toString(anglCur[0]));
		
		if (angl > 0) {
			anglSet = (anglCur[0] + angl < H_NuiImageCamera.NUI_CAMERA_ELEVATION_MAXIMUM)
					? anglCur[0] + angl : H_NuiImageCamera.NUI_CAMERA_ELEVATION_MAXIMUM;
		}
		else if (angl < 0) {
			anglSet = (anglCur[0] + angl > H_NuiImageCamera.NUI_CAMERA_ELEVATION_MINIMUM)
					? anglCur[0] + angl : H_NuiImageCamera.NUI_CAMERA_ELEVATION_MINIMUM;
		}
		else {
			anglSet = 0;
		}
		wins.NuiCameraElevationSetAngle(anglSet);
		blUp = false;
		blDown = false;
	}
	
	void terminate() throws Exception_KINECT, Exception_Win64 {
		if (wiftiColor != null) wiftiColor.Release();
		if (wiftiDepth != null) wiftiDepth.Release();
		if (wiftr != null) wiftr.Release();
		if (wiftft != null) wiftft.Release();

		if (kinect[0] != 0) {
			if (wmap != null) {
				wmap.Release();
			}
			if (wins != null) {
				setAngle(0);
				wins.NuiSkeletonTrackingDisable();
				wins.NuiShutdown();
				wins.Release();
			}
		}
		if (wkrnl != null) {
			if (hColorEvent != 0) wkrnl.CloseHandle(hColorEvent);
			if (hDepthEvent != 0) wkrnl.CloseHandle(hDepthEvent);
			if (hSkeletonEvent != 0) wkrnl.CloseHandle(hSkeletonEvent);
		}
		if (grphOff != null) grphOff.dispose();
	}
	
}
