package testkinect;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import utildll.*;

public class TestKINECT103 extends JFrame implements Runnable, ActionListener {
	Wrp_KINECT wk = new Wrp_KINECT();
	Wrp_INuiSensor wins = null;
	Wrp_Kernel32 wkrnl = new Wrp_Kernel32();
	Wrp_JInvoker wjinv = new Wrp_JInvoker();
	long[] kinect = {0};
	long[] hColor = {0};
	long[] hDepth = {0};
	long hColorEvent = 0;
	long hDepthEvent = 0;
	long hSkeletonEvent = 0;
	int[] width = {0};
	int[] height = {0};
	int[] color;
	
	//background removal
    final String BACKGROUND_IMAGE_FILE = "background.jpg";
	Wrp_BackgroundRemoval wbr = new Wrp_BackgroundRemoval();
	Wrp_INuiBackgroundRemovedColorStream winbrcs = null;
	Image backImage;
	long[] backRemove = {0};
	long hBackRemoveEvent = 0;
	int[] removedColor;
	int[] backColor;
	
	final int IMG_WIDTH = 640;
	final int IMG_HEIGHT = 480;
	final int BORDER_WIDTH = 4;
	final int TITLE_HEIGHT = 30;
	final int PANEL_HEIGHT = 40;
	JButton btnUp, btnDown, btnExit;
	boolean blUp = false, blDown = false, blExit = false; 
	JPanel pnl;
	ImageCanvas imgcvs;
	BufferedImage bfimgOff = new BufferedImage(IMG_WIDTH, IMG_HEIGHT, BufferedImage.TYPE_INT_RGB);
	Graphics grphOff = bfimgOff.getGraphics();
	boolean blPaint = false;
	
	public static void main(String[] args) {
		TestKINECT103 testkinect = new TestKINECT103();
	}
	
	TestKINECT103() {
		this.setTitle("KINECT_TEST103");
		this.setSize(IMG_WIDTH + BORDER_WIDTH * 2, IMG_HEIGHT + TITLE_HEIGHT + PANEL_HEIGHT + BORDER_WIDTH);
		this.setLocationRelativeTo(null);
		this.setLayout(null);
		this.setResizable(false);
		
		imgcvs = new ImageCanvas();
		imgcvs.setBounds(0, 0, IMG_WIDTH, IMG_HEIGHT);
		getContentPane().add(imgcvs);
		
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT, 10, 5));
		pnl.setBounds(0, IMG_HEIGHT, IMG_WIDTH, PANEL_HEIGHT);
		
		btnUp = new JButton("   Up   ");
		btnUp.addActionListener(this);
		pnl.add(btnUp);
		
		btnDown = new JButton("  Down  ");
		btnDown.addActionListener(this);
		pnl.add(btnDown);
		
		btnExit = new JButton("  Exit  ");
		btnExit.addActionListener(this);
		pnl.add(btnExit);
		
		getContentPane().add(pnl);
		
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent ev) {
				System.exit(0);
			}
		});

		backColor = new int[IMG_WIDTH * IMG_HEIGHT];
		
		//read background image 
		readBackImage();
		
		// set background image
		bfimgOff.setRGB(0, 0, IMG_WIDTH, IMG_HEIGHT, backColor, 0, IMG_WIDTH);

		this.setVisible(true);

		Thread thread = new Thread(this);
		thread.start();
	}
	
	void readBackImage() {
        backImage = Toolkit.getDefaultToolkit().getImage(BACKGROUND_IMAGE_FILE);
        PixelGrabber pg = new PixelGrabber(backImage, 0, 0, IMG_WIDTH, IMG_HEIGHT, backColor, 0, IMG_WIDTH);
        try {
           pg.grabPixels();
        } catch(InterruptedException ie) {}
	}

	public void actionPerformed(ActionEvent e) {
		JButton btn = (JButton)e.getSource();
		if (btn == btnUp) {
			blUp = true;
		}
		else if (btn == btnDown) {
			blDown = true;
		}
		else if (btn == btnExit) {
			blExit = true;
		}
	}

	class ImageCanvas extends Canvas {
		public void paint(Graphics g){
			if (blPaint == true) {
				g.drawImage(bfimgOff, 0, 0, this);
				blPaint = false;
			}
		}
		
		public void update(Graphics g){
			paint(g);
		}
	}

	public void run() {
		try {
			initialize();
			drawcvs();
		}
		catch (Exception_KINECT e) {
			System.out.println("***** Exception_KINECT: " + e.getMessage());
		}
		catch (Exception_Win64 e) {
			System.out.println("***** Exception_Win64: " + e.getMessage());
		}
		catch (Exception_JInvoker e) {
			System.out.println("***** Exception_JInvoker: " + e.getMessage());
		}
		finally {
			System.out.println("finally start ");
			try {
				terminate();
			}
			catch (Exception_KINECT e) {
				System.out.println("***** Exception_KINECT: " + e.getMessage());
			}
			catch (Exception_Win64 e) {
				System.out.println("***** Exception_Win64: " + e.getMessage());
			}
			System.out.println("finally end ");
		}
		System.exit(0);
	}
	
	void initialize() throws Exception_KINECT, Exception_Win64 {
		// create Kinect instance
		int[] count = {0};
		wk.NuiGetSensorCount(count);
		System.out.println("sensor count: " + Integer.toString(count[0]));
		
		wk.NuiCreateSensorByIndex(0, kinect);
		System.out.println("instance#0: " + Long.toHexString(kinect[0]));
		
		wins = new Wrp_INuiSensor(kinect[0]);
		int sts = wins.NuiStatus();
		System.out.println("status: " + Integer.toHexString(sts));
		
		// initialize
		wins.NuiInitialize(H_NuiApi.NUI_INITIALIZE_FLAG_USES_COLOR
				| H_NuiApi.NUI_INITIALIZE_FLAG_USES_DEPTH_AND_PLAYER_INDEX
				| H_NuiApi.NUI_INITIALIZE_FLAG_USES_SKELETON);
		
		// open color stream
		hColorEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiImageStreamOpen(H_NuiImageCamera.NUI_IMAGE_TYPE_COLOR,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, 0, 2, hColorEvent, hColor);
		System.out.println("color stream: " + Long.toHexString(hColor[0]));
		
		// open depth stream
		hDepthEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiImageStreamOpen(H_NuiImageCamera.NUI_IMAGE_TYPE_DEPTH_AND_PLAYER_INDEX,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, 0, 2, hDepthEvent, hDepth);
		System.out.println("depth stream: " + Long.toHexString(hDepth[0]));

		// near mode
		//wins.NuiImageStreamSetImageFrameFlags(hDepth[0],
		//		H_NuiImageCamera.NUI_IMAGE_STREAM_FLAG_ENABLE_NEAR_MODE);
		
		// enable skeleton tracking
		hSkeletonEvent = wkrnl.CreateEvent(null, true, false, null);
		wins.NuiSkeletonTrackingEnable(hSkeletonEvent, 0);
		
		// back remove stream
		wbr.NuiCreateBackgroundRemovedColorStream(kinect[0], backRemove);
		System.out.println("back remove stream: " + Long.toHexString(backRemove[0]));
		
		winbrcs = new Wrp_INuiBackgroundRemovedColorStream(backRemove[0]);
		hBackRemoveEvent = wkrnl.CreateEvent(null, true, false, null);
		winbrcs.Enable(H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480,
				H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, hBackRemoveEvent);
		
		// get width and height
		wk.NuiImageResolutionToSize(H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480, width, height);
		System.out.println("camera size: " + Integer.toString(width[0]) + "x"
				+ Integer.toString(height[0]));
		
		color = new int[width[0] * height[0]];
		removedColor = new int[width[0] * height[0]];
		
	}
	
	void drawcvs() throws Exception_KINECT, Exception_Win64, Exception_JInvoker {
		
		for (;;) {
			
			setRemovedColorImage();
			
			blPaint = true;
			imgcvs.repaint();
			
			if (blUp) {
				setAngle(+5);
			}
			if(blDown) {	
				setAngle(-5);
			}
			if (blExit) {
				break;
			}
		}
	}

	void setRemovedColorImage() throws Exception_KINECT, Exception_Win64, Exception_JInvoker {
		int rtn;
		rtn = wkrnl.WaitForSingleObject(hColorEvent, 0);
		if (rtn == H_WinBase.WAIT_OBJECT_0) {
			// get color frame
			Struct_NUI_IMAGE_FRAME colorFrame = new Struct_NUI_IMAGE_FRAME();
			wins.NuiImageStreamGetNextFrame(hColor[0], 0, colorFrame);
			
			Wrp_INuiFrameTexture winftColor = new Wrp_INuiFrameTexture(colorFrame.pFrameTexture);
			
			Struct_NUI_LOCKED_RECT colorRect = new Struct_NUI_LOCKED_RECT();
			winftColor.LockRect(0, colorRect, null, 0);
	
			System.out.println("color data adrs: " + Long.toHexString(colorRect.pBits));
			
			// back remove process
			winbrcs.ProcessColor(colorRect.size, colorRect.pBits, colorFrame.liTimeStamp);
			
			winftColor.UnlockRect(0);
			wins.NuiImageStreamReleaseFrame(hColor[0], colorFrame);
		}
		
		rtn = wkrnl.WaitForSingleObject(hDepthEvent, 0);
		if (rtn == H_WinBase.WAIT_OBJECT_0) {
			// get depth frame
			Struct_NUI_IMAGE_FRAME depthFrame = new Struct_NUI_IMAGE_FRAME();
			wins.NuiImageStreamGetNextFrame(hDepth[0], 0, depthFrame);
			
			boolean[] pNearMode = {false};
			long[] ppFrameTexture = {0};
			wins.NuiImageFrameGetDepthImagePixelFrameTexture(hDepth[0], depthFrame, pNearMode,
					ppFrameTexture);
			
			Wrp_INuiFrameTexture winftDepth = new Wrp_INuiFrameTexture(ppFrameTexture[0]);
			
			Struct_NUI_LOCKED_RECT depthRect = new Struct_NUI_LOCKED_RECT();
			winftDepth.LockRect(0, depthRect, null, 0);
			
			System.out.println("depth data adrs: " + Long.toHexString(depthRect.pBits));
			
			// back remove process
			winbrcs.ProcessDepth(depthRect.size, depthRect.pBits, depthFrame.liTimeStamp);
			
			winftDepth.UnlockRect(0);
			wins.NuiImageStreamReleaseFrame(hDepth[0], depthFrame);
		}
		
		rtn = wkrnl.WaitForSingleObject(hSkeletonEvent, 0);
		if (rtn == H_WinBase.WAIT_OBJECT_0) {
			// get skeleton frame
			Struct_NUI_SKELETON_FRAME skeletonFrame = new Struct_NUI_SKELETON_FRAME();
			int hr = wins.NuiSkeletonGetNextFrame(0, skeletonFrame);
		
			if (H_WinError.SUCCEEDED(hr)) {
				// back remove process
				winbrcs.ProcessSkeleton(H_NuiSkeleton.NUI_SKELETON_COUNT,
						skeletonFrame.SkeletonData, skeletonFrame.liTimeStamp);
				
				// search tracking skeleton
				int trackingID = H_NuiSkeleton.NUI_SKELETON_INVALID_TRACKING_ID;
				for (int i = 0; i < H_NuiSkeleton.NUI_SKELETON_COUNT; i++) {
					Struct_NUI_SKELETON_DATA skeletonData = skeletonFrame.SkeletonData[i];
					if (skeletonData.eTrackingState == H_NuiSkeleton.NUI_SKELETON_TRACKED) {
						trackingID = skeletonData.dwTrackingID;
						break;
					}
				}
				
				// set tracking skeleton id
				if (trackingID != H_NuiSkeleton.NUI_SKELETON_INVALID_TRACKING_ID) {
					winbrcs.SetTrackedPlayer(trackingID);
				}
			}
		}
		
		rtn = wkrnl.WaitForSingleObject(hBackRemoveEvent, 0);
		if (rtn == H_WinBase.WAIT_OBJECT_0) {
			Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME backRemoveFrame =
					new Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME();
			int hr = winbrcs.GetNextFrame(0, backRemoveFrame);
			
			if (H_WinError.SUCCEEDED(hr)) {
				// copy background removed color data
				wjinv.movePtrToIntArray(removedColor, backRemoveFrame.pBackgroundRemovedColorData);
				
				// merge background removed color data and background color data
				for (int i = 0; i < width[0] * height[0]; i++) {
                    int remove = removedColor[i];
                    int a1 = (remove >> 24) & 0xff;
                    int r1 = (remove >> 16) & 0xff;
                    int g1 = (remove >>  8) & 0xff;
                    int b1 = remove & 0xff;
                    
                    int back = backColor[i];
                    int r2 = (back >> 16) & 0xff;
                    int g2 = (back >>  8) & 0xff;
                    int b2 = back & 0xff;
                    
                    int r3 = ((a1 * r1) + ((255 - a1) * r2)) / 255;
                    int g3 = ((a1 * g1) + ((255 - a1) * g2)) / 255;
                    int b3 = ((a1 * b1) + ((255 - a1) * b2)) / 255;
                    
                    color[i] = 0xff000000 | r3 << 16 | g3 << 8 | b3;
				}
				// set color image
				bfimgOff.setRGB(0, 0, IMG_WIDTH, IMG_HEIGHT, color, 0, IMG_WIDTH);
				
				winbrcs.ReleaseFrame(backRemoveFrame);
			}
		}
	}
	
	void setAngle(int angl) throws Exception_KINECT {
		int[] anglCur = {0};
		int anglSet = 0;
		
		wins.NuiCameraElevationGetAngle(anglCur);
		System.out.println("anglCur: " + Integer.toString(anglCur[0]));
		
		if (angl > 0) {
			anglSet = (anglCur[0] + angl < H_NuiImageCamera.NUI_CAMERA_ELEVATION_MAXIMUM)
					? anglCur[0] + angl : H_NuiImageCamera.NUI_CAMERA_ELEVATION_MAXIMUM;
		}
		else if (angl < 0) {
			anglSet = (anglCur[0] + angl > H_NuiImageCamera.NUI_CAMERA_ELEVATION_MINIMUM)
					? anglCur[0] + angl : H_NuiImageCamera.NUI_CAMERA_ELEVATION_MINIMUM;
		}
		else {
			anglSet = 0;
		}
		wins.NuiCameraElevationSetAngle(anglSet);
		blUp = false;
		blDown = false;
	}
	
	void terminate() throws Exception_KINECT, Exception_Win64 {
		if (winbrcs != null) {
			winbrcs.Disable();
			winbrcs.Release();
		}
		if (kinect[0] != 0) {
			if (wins != null) {
				setAngle(0);
				wins.NuiSkeletonTrackingDisable();
				wins.NuiShutdown();
				wins.Release();
			}
		}
		if (wkrnl != null) {
			if (hColorEvent != 0) wkrnl.CloseHandle(hColorEvent);
			if (hDepthEvent != 0) wkrnl.CloseHandle(hDepthEvent);
			if (hSkeletonEvent != 0) wkrnl.CloseHandle(hSkeletonEvent);
			if (hBackRemoveEvent != 0) wkrnl.CloseHandle(hBackRemoveEvent);
		}
		if (grphOff != null) grphOff.dispose();
	}
	
}
