package testkinect;

import utildll.*;

public class Wrp_BackgroundRemoval {
	static final int CHARSET = Arg.UNICODE;
	static final String BACKGROUNDREMOVAL_DLL_NAME = "KinectBackgroundRemoval180_64";
	private String[] strFncName = {
			"NuiCreateBackgroundRemovedColorStream"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_NuiCreateBackgroundRemovedColorStream = 0;
	private long hMod = 0;
	
	Wrp_BackgroundRemoval() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(BACKGROUNDREMOVAL_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " FncName: " + strFncName[i]);
		}
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT NuiCreateBackgroundRemovedColorStream(
	         INuiSensor *pNuiSensor,
	         INuiBackgroundRemovedColorStream **ppBackgroundRemovedColorStream
	)
	 */
	class Arg_NuiCreateBackgroundRemovedColorStream extends Arg_property {
		private long pNuiSensor; // INuiSensor *
		private long[] ppBackgroundRemovedColorStream; // INuiBackgroundRemovedColorStream **

		Arg_NuiCreateBackgroundRemovedColorStream(long pNuiSensor, long[] ppBackgroundRemovedColorStream) {
			this.pNuiSensor = pNuiSensor;
			this.ppBackgroundRemovedColorStream = ppBackgroundRemovedColorStream;
		}
	}
	
	int NuiCreateBackgroundRemovedColorStream(long pNuiSensor, long[] ppBackgroundRemovedColorStream)
			throws Exception_KINECT {
		Arg_NuiCreateBackgroundRemovedColorStream ancbrcs
				= new Arg_NuiCreateBackgroundRemovedColorStream(pNuiSensor, ppBackgroundRemovedColorStream);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiCreateBackgroundRemovedColorStream],
				ancbrcs);
		
		System.out.println("NuiCreateBackgroundRemovedColorStream rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ancbrcs.getLastError()));
		
		if (ancbrcs.getLastError() < 0) throw new Exception_KINECT("NuiCreateBackgroundRemovedColorStream");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiCreateBackgroundRemovedColorStream");
		
		return intRtn;
	}
	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}
	
}
