package testkinect;

import utildll.*;

class Wrp_FaceTracker {
	static final int CHARSET = Arg.UNICODE;
	static final String FACETRACKER_DLL_NAME = "FaceTrackLib";
	private String[] strFncName = {
			"FTCreateFaceTracker",
			"FTCreateImage"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_FTCreateFaceTracker = 0,
			IDX_FTCreateImage = 1;
	private long hMod = 0;
	
	Wrp_FaceTracker() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(FACETRACKER_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " FncName: " + strFncName[i]);
		}
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	IFTFaceTracker* FTCreateFaceTracker(
		PVOID reserved = NULL
	)
	 */
	class Arg_FTCreateFaceTracker extends Arg_property {
		private long reserved = 0;

		Arg_FTCreateFaceTracker() {
		}
	}
	
	long FTCreateFaceTracker() throws Exception_KINECT {
		Arg_FTCreateFaceTracker aftcft = new Arg_FTCreateFaceTracker();

		long lngRtn = JInvoker.callLongProcAddress(lngFncAdrs[IDX_FTCreateFaceTracker], aftcft);
		
		System.out.println("FTCreateFaceTracker rtn: " + Long.toHexString(lngRtn)
				+ " LastError: " + Integer.toString(aftcft.getLastError()));
		
		if (aftcft.getLastError() < 0) throw new Exception_KINECT("FTCreateFaceTracker");
		if (lngRtn == 0) throw new Exception_KINECT("FTCreateFaceTracker");
		
		return lngRtn;
	}

	/*
	IFTImage* FTCreateImage()
	 */
	class Arg_FTCreateImage extends Arg_property {
		Arg_FTCreateImage() {
		}
	}
	
	long FTCreateImage() throws Exception_KINECT {
		Arg_FTCreateImage aftci = new Arg_FTCreateImage();

		long lngRtn = JInvoker.callLongProcAddress(lngFncAdrs[IDX_FTCreateImage], aftci);
		
		System.out.println("FTCreateImage rtn: " + Long.toHexString(lngRtn)
				+ " LastError: " + Integer.toString(aftci.getLastError()));
		
		if (aftci.getLastError() < 0) throw new Exception_KINECT("FTCreateImage");
		if (lngRtn == 0) throw new Exception_KINECT("FTCreateImage");
		
		return lngRtn;
	}

	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}
	
}
