package testkinect;

import utildll.*;

class Wrp_IFTFaceTracker {
	static final int CHARSET = Arg.UNICODE;
	long faceTracker = 0;
	static final int
		IDX_Release = 2,
		IDX_Initialize = 3,
		IDX_CreateFTResult = 5,
		IDX_GetFaceModel = 10,
		IDX_StartTracking = 11,
		IDX_ContinueTracking = 12,
		IDX_DetectFaces = 13;
	
	Wrp_IFTFaceTracker(long faceTracker) {
		this.faceTracker = faceTracker;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(faceTracker, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT Initialize(
	         const FT_CAMERA_CONFIG* pVideoCameraConfig,
	         const FT_CAMERA_CONFIG* pDepthCameraConfig,
	         FTRegisterDepthToColor depthToColorMappingFunc,
	         PCWSTR pszModelPath
	)
	 */
	class Arg_Initialize extends Arg_property {
		private @_Const Struct_FT_CAMERA_CONFIG pVideoCameraConfig;
		private @_Const Struct_FT_CAMERA_CONFIG pDepthCameraConfig;
		private long depthToColorMappingFunc;
		private @_Const @_Unicode String pszModelPath;

		Arg_Initialize(Struct_FT_CAMERA_CONFIG pVideoCameraConfig, Struct_FT_CAMERA_CONFIG pDepthCameraConfig,
				long depthToColorMappingFunc, String pszModelPath) {
			this.pVideoCameraConfig = pVideoCameraConfig;
			this.pDepthCameraConfig = pDepthCameraConfig;
			this.depthToColorMappingFunc = depthToColorMappingFunc;
			this.pszModelPath = pszModelPath;
		}
	}

	int Initialize(Struct_FT_CAMERA_CONFIG pVideoCameraConfig, Struct_FT_CAMERA_CONFIG pDepthCameraConfig,
			long depthToColorMappingFunc, String pszModelPath) throws Exception_KINECT {
		Arg_Initialize ai = new Arg_Initialize(pVideoCameraConfig, pDepthCameraConfig,
				depthToColorMappingFunc, pszModelPath);

		int intRtn = JInvoker.callIntMethod(faceTracker, IDX_Initialize, ai);
		
		System.out.println("Initialize rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ai.getLastError()));
		
		if (ai.getLastError() < 0) throw new Exception_KINECT("Initialize");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Initialize");

		return intRtn;
	}
	
	/*
	HRESULT CreateFTResult(
	         IFTResult** ppFTResult
	)
	 */
	class Arg_CreateFTResult extends Arg_property {
		private long[] ppFTResult; // IFTResult**

		Arg_CreateFTResult(long[] ppFTResult) {
			this.ppFTResult = ppFTResult;
		}
	}

	int CreateFTResult(long[] ppFTResult) throws Exception_KINECT {
		Arg_CreateFTResult acftr = new Arg_CreateFTResult(ppFTResult);

		int intRtn = JInvoker.callIntMethod(faceTracker, IDX_CreateFTResult, acftr);
		
		System.out.println("CreateFTResult rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(acftr.getLastError()));
		
		if (acftr.getLastError() < 0) throw new Exception_KINECT("CreateFTResult");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CreateFTResult");

		return intRtn;
	}

	/*
	HRESULT GetFaceModel(
	         IFTModel** ppModel
	)
	 */
	class Arg_GetFaceModel extends Arg_property {
		private long[] ppModel; // IFTModel**

		Arg_GetFaceModel(long[] ppModel) {
			this.ppModel = ppModel;
		}
	}

	int GetFaceModel(long[] ppModel) throws Exception_KINECT {
		Arg_GetFaceModel agfm = new Arg_GetFaceModel(ppModel);

		int intRtn = JInvoker.callIntMethod(faceTracker, IDX_GetFaceModel, agfm);
		
		System.out.println("GetFaceModel rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(agfm.getLastError()));
		
		if (agfm.getLastError() < 0) throw new Exception_KINECT("GetFaceModel");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetFaceModel");

		return intRtn;
	}

	/*
	HRESULT StartTracking(
	         const FT_SENSOR_DATA* pSensorData,
	         const RECT* pRoi,
	         const FT_VECTOR3D headPoints[2],
	         IFTResult* pFTResult
	)
	 */
	class Arg_StartTracking extends Arg_property {
		private @_Const Struct_FT_SENSOR_DATA pSensorData;
		private @_Const Struct_RECT pRoi;
		private @_Const Struct_FT_VECTOR3D[] headPoints;
		private long pFTResult; // IFTResult*

		Arg_StartTracking(Struct_FT_SENSOR_DATA pSensorData, Struct_RECT pRoi,
				Struct_FT_VECTOR3D[] headPoints, long pFTResult) {
			this.pSensorData = pSensorData;
			this.pRoi = pRoi;
			this.headPoints = headPoints;
			this.pFTResult = pFTResult;
		}
	}

	int StartTracking(Struct_FT_SENSOR_DATA pSensorData, Struct_RECT pRoi,
			Struct_FT_VECTOR3D[] headPoints, long pFTResult) throws Exception_KINECT {
		Arg_StartTracking ast = new Arg_StartTracking(pSensorData, pRoi, headPoints, pFTResult);

		int intRtn = JInvoker.callIntMethod(faceTracker, IDX_StartTracking, ast);
		
		System.out.println("StartTracking rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ast.getLastError()));
		
		if (ast.getLastError() < 0) throw new Exception_KINECT("StartTracking");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("StartTracking");

		return intRtn;
	}

	/*
	HRESULT ContinueTracking(
	         const FT_SENSOR_DATA* pSensorData,
	         const FT_VECTOR3D headPoints[2],
	         IFTResult* pFTResult
	)
	 */
	class Arg_ContinueTracking extends Arg_property {
		private @_Const Struct_FT_SENSOR_DATA pSensorData;
		private @_Const Struct_FT_VECTOR3D[] headPoints;
		private long pFTResult; // IFTResult*

		Arg_ContinueTracking(Struct_FT_SENSOR_DATA pSensorData, Struct_FT_VECTOR3D[] headPoints,
					long pFTResult) {
			this.pSensorData = pSensorData;
			this.headPoints = headPoints;
			this.pFTResult = pFTResult;
		}
	}

	int ContinueTracking(Struct_FT_SENSOR_DATA pSensorData, Struct_FT_VECTOR3D[] headPoints,
				long pFTResult) throws Exception_KINECT {
		Arg_ContinueTracking act = new Arg_ContinueTracking(pSensorData, headPoints, pFTResult);

		int intRtn = JInvoker.callIntMethod(faceTracker, IDX_ContinueTracking, act);
		
		System.out.println("ContinueTracking rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(act.getLastError()));
		
		if (act.getLastError() < 0) throw new Exception_KINECT("ContinueTracking");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ContinueTracking");

		return intRtn;
	}
	
	/*
	HRESULT DetectFaces(
	         const FT_SENSOR_DATA* pSensorData,
	         const RECT* pRoi,
	         FT_WEIGHTED_RECT* pFaces,
	         UINT* pFaceCount
	)
	 */
	class Arg_DetectFaces extends Arg_property {
		private @_Const Struct_FT_SENSOR_DATA pSensorData;
		private @_Const Struct_RECT pRoi;
		private Struct_FT_WEIGHTED_RECT[] pFaces;
		private int[] pFaceCount;

		Arg_DetectFaces(Struct_FT_SENSOR_DATA pSensorData, Struct_RECT pRoi, Struct_FT_WEIGHTED_RECT[] pFaces,
				int[] pFaceCount) {
			this.pSensorData = pSensorData;
			this.pRoi = pRoi;
			this.pFaces = pFaces;
			this.pFaceCount = pFaceCount;
		}
	}

	int DetectFaces(Struct_FT_SENSOR_DATA pSensorData, Struct_RECT pRoi, Struct_FT_WEIGHTED_RECT[] pFaces,
			int[] pFaceCount) throws Exception_KINECT {
		Arg_DetectFaces adf = new Arg_DetectFaces(pSensorData, pRoi, pFaces, pFaceCount);

		int intRtn = JInvoker.callIntMethod(faceTracker, IDX_DetectFaces, adf);
		
		System.out.println("DetectFaces rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(adf.getLastError()));
		
		if (adf.getLastError() < 0) throw new Exception_KINECT("DetectFaces");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("DetectFaces");

		return intRtn;
	}

}
