package testkinect;

import utildll.*;

class Wrp_IFTImage {
	static final int CHARSET = Arg.UNICODE;
	long image = 0;
	static final int
		IDX_Release = 2,
		IDX_Allocate = 3,
		IDX_Attach = 4,
		IDX_GetBuffer = 12,
		IDX_CopyTo = 14;
	
	Wrp_IFTImage(long image) {
		this.image = image;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(image, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT Allocate(
		UINT width,
		UINT height,
		FTIMAGEFORMAT format
	)
	 */
	class Arg_Allocate extends Arg_property {
		private int width;
		private int height;
		private int format;
		
		Arg_Allocate(int width, int height, int format) {
			this.width = width;
			this.height = height;
			this.format = format;
		}
	}
	
	int Allocate(int width, int height, int format) throws Exception_KINECT {
		Arg_Allocate aa = new Arg_Allocate(width, height, format);

		int intRtn = JInvoker.callIntMethod(image, IDX_Allocate, aa);
		
		System.out.println("Allocate rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(aa.getLastError()));
		
		if (aa.getLastError() < 0) throw new Exception_KINECT("Allocate");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Allocate");

		return intRtn;
	}
	
	/*
	HRESULT Attach(
		UINT width,
		UINT height,
		void* pData,
		FTIMAGEFORMAT format,
		UINT stride
	)
	 */
	class Arg_Attach extends Arg_property {
		private int width;
		private int height;
		private long pData; // void*
		private int format;
		private int stride;
		
		Arg_Attach(int width, int height, long pData, int format, int stride) {
			this.width = width;
			this.height = height;
			this.pData = pData;
			this.format = format;
			this.stride = stride;
		}
	}
	
	int Attach(int width, int height, long pData, int format, int stride) throws Exception_KINECT {
		Arg_Attach aa = new Arg_Attach(width, height, pData, format, stride);

		int intRtn = JInvoker.callIntMethod(image, IDX_Attach, aa);
		
		System.out.println("Attach rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(aa.getLastError()));
		
		if (aa.getLastError() < 0) throw new Exception_KINECT("Attach");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Attach");

		return intRtn;
	}

	/*
	BYTE* GetBuffer()
	 */
	class Arg_GetBuffer extends Arg_property {
	}
	
	long GetBuffer() throws Exception_KINECT {
		Arg_GetBuffer agb = new Arg_GetBuffer();

		long lngRtn = JInvoker.callLongMethod(image, IDX_GetBuffer, agb);
		
		System.out.println("GetBuffer rtn: " + Long.toString(lngRtn)
				+ " LastError: " + Integer.toString(agb.getLastError()));
		
		if (agb.getLastError() < 0) throw new Exception_KINECT("GetBuffer");

		return lngRtn;
	}
	
	/*
	HRESULT CopyTo(
		IFTImage* pDestImage,
		const RECT* pSrcRect,
		UINT destRow,
		UINT destColumn
	)
	 */
	class Arg_CopyTo extends Arg_property {
		private long pDestImage; // IFTImage*
		private @_Const Struct_RECT pSrcRect;
		private int destRow;
		private int destColumn;
		
		Arg_CopyTo(long pDestImage, Struct_RECT pSrcRect, int destRow, int destColumn) {
			this.pDestImage = pDestImage;
			this.pSrcRect = pSrcRect;
			this.destRow = destRow;
			this.destColumn = destColumn;
		}
	}
	
	int CopyTo(long pDestImage, Struct_RECT pSrcRect, int destRow, int destColumn) throws Exception_KINECT {
		Arg_CopyTo act = new Arg_CopyTo(pDestImage, pSrcRect, destRow, destColumn);

		int intRtn = JInvoker.callIntMethod(image, IDX_CopyTo, act);
		
		System.out.println("CopyTo rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(act.getLastError()));
		
		if (act.getLastError() < 0) throw new Exception_KINECT("CopyTo");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CopyTo");

		return intRtn;
	}

}