package testkinect;

import utildll.*;

class Wrp_IFTModel {
	static final int CHARSET = Arg.UNICODE;
	long model = 0;
	static final int
		IDX_Release = 2,
		IDX_GetSUCount = 3,
		IDX_GetAUCount = 4,
		IDX_GetTriangles = 5,
		IDX_GetVertexCount = 6,
		IDX_Get3DShape = 7;
	
	Wrp_IFTModel(long model) {
		this.model = model;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(model, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	UINT GetSUCount()
	 */
	class Arg_GetSUCount extends Arg_property {
	}
	
	int GetSUCount() throws Exception_KINECT {
		Arg_GetSUCount agsuc = new Arg_GetSUCount();

		int intRtn = JInvoker.callIntMethod(model, IDX_GetSUCount, agsuc);
		
		System.out.println("GetSUCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(agsuc.getLastError()));
		
		if (agsuc.getLastError() < 0) throw new Exception_KINECT("GetSUCount");

		return intRtn;
	}
	
	/*
	UINT GetAUCount()
	 */
	class Arg_GetAUCount extends Arg_property {
	}
	
	int GetAUCount() throws Exception_KINECT {
		Arg_GetAUCount agauc = new Arg_GetAUCount();

		int intRtn = JInvoker.callIntMethod(model, IDX_GetAUCount, agauc);
		
		System.out.println("GetAUCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(agauc.getLastError()));
		
		if (agauc.getLastError() < 0) throw new Exception_KINECT("GetAUCount");

		return intRtn;
	}

	/*
	HRESULT GetTriangles(
		FT_TRIANGLE** ppTriangles,
		UINT* pTriangleCount
	)
	 */
	class Arg_GetTriangles extends Arg_property {
		private Struct_REF_FT_TRIANGLE ppTriangles = new Struct_REF_FT_TRIANGLE();
		private int[] pTriangleCount;
		
		Arg_GetTriangles(int[] pTriangleCount) {
			this.pTriangleCount = pTriangleCount;
		}
		
		Struct_FT_TRIANGLE[] getTriangles() {return this.ppTriangles.pTriangles;}
	}
	
	class Struct_REF_FT_TRIANGLE {
		@_Length_is("pTriangleCount") Struct_FT_TRIANGLE[] pTriangles = null;
	}
	
	Struct_FT_TRIANGLE[] GetTriangles(int[] pTriangleCount) throws Exception_KINECT {
		Arg_GetTriangles agt = new Arg_GetTriangles(pTriangleCount);

		int intRtn = JInvoker.callIntMethod(model, IDX_GetTriangles, agt);
		
		System.out.println("GetTriangles rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(agt.getLastError()));
		
		if (agt.getLastError() < 0) throw new Exception_KINECT("GetTriangles");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetTriangles");
		
		return agt.getTriangles();
	}

	/*
	UINT GetVertexCount()
	 */
	class Arg_GetVertexCount extends Arg_property {
	}
	
	int GetVertexCount() throws Exception_KINECT {
		Arg_GetVertexCount agvc = new Arg_GetVertexCount();

		int intRtn = JInvoker.callIntMethod(model, IDX_GetVertexCount, agvc);
		
		System.out.println("GetVertexCount rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(agvc.getLastError()));
		
		if (agvc.getLastError() < 0) throw new Exception_KINECT("GetVertexCount");

		return intRtn;
	}

	/*
	HRESULT Get3DShape(
		const FLOAT *pSUCoefs,
		UINT suCount,
		const FLOAT *pAUCoefs,
		UINT auCount,
		FLOAT scale,
		const FLOAT roationXYZ[3],
		const FLOAT translationXYZ[3],
		FT_VECTOR3D *pVertices,
		UINT vertexCount
	)
	 */
	class Arg_Get3DShape extends Arg_property {
		private @_Const float[] pSUCoefs;
		private int suCount;
		private @_Const float[] pAUCoefs;
		private int auCount;
		private float scale;
		private @_Const float[] roationXYZ;
		private @_Const float[] translationXYZ;
		private Struct_FT_VECTOR3D[] pVertices;
		private int vertexCount;
		
		Arg_Get3DShape(float[] pSUCoefs, int suCount, float[] pAUCoefs, int auCount, float scale,
				float[] roationXYZ, float[] translationXYZ, Struct_FT_VECTOR3D[] pVertices, int vertexCount) {
			this.pSUCoefs = pSUCoefs;
			this.suCount = suCount;
			this.pAUCoefs = pAUCoefs;
			this.auCount = auCount;
			this.scale = scale;
			this.roationXYZ = roationXYZ;
			this.translationXYZ = translationXYZ;
			this.pVertices = pVertices;
			this.vertexCount = vertexCount;
		}
	}
	
	int Get3DShape(float[] pSUCoefs, int suCount, float[] pAUCoefs, int auCount, float scale,
			float[] roationXYZ, float[] translationXYZ, Struct_FT_VECTOR3D[] pVertices, int vertexCount)
			throws Exception_KINECT {
		Arg_Get3DShape ag3ds = new Arg_Get3DShape(pSUCoefs, suCount, pAUCoefs, auCount, scale,
				roationXYZ, translationXYZ, pVertices, vertexCount);

		int intRtn = JInvoker.callIntMethod(model, IDX_Get3DShape, ag3ds);
		
		System.out.println("Get3DShape rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ag3ds.getLastError()));
		
		if (ag3ds.getLastError() < 0) throw new Exception_KINECT("Get3DShape");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Get3DShape");

		return intRtn;
	}

}