package testkinect;

import utildll.*;

public class Wrp_IFTResult {
	static final int CHARSET = Arg.UNICODE;
	long result = 0;
	static final int
		IDX_Release = 2,
		IDX_GetStatus = 5,
		IDX_GetFaceRect = 6,
		IDX_Get2DShapePoints = 7,
		IDX_Get3DPose = 8;
	
	Wrp_IFTResult(long result) {
		this.result = result;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(result, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT GetStatus()
	 */
	class Arg_GetStatus extends Arg_property {
	}
	
	int GetStatus() throws Exception_KINECT {
		Arg_GetStatus ags = new Arg_GetStatus();

		int intRtn = JInvoker.callIntMethod(result, IDX_GetStatus, ags);
		
		System.out.println("GetStatus rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ags.getLastError()));
		
		if (ags.getLastError() < 0) throw new Exception_KINECT("GetStatus");

		return intRtn;
	}
	
	/*
	HRESULT GetFaceRect(
		RECT* pRect
	)
	 */
	class Arg_GetFaceRect extends Arg_property {
		private Struct_RECT pRect;
		
		Arg_GetFaceRect(Struct_RECT pRect) {
			this.pRect = pRect;
		}
	}
	
	int GetFaceRect(Struct_RECT pRect) throws Exception_KINECT {
		Arg_GetFaceRect agfr = new Arg_GetFaceRect(pRect);

		int intRtn = JInvoker.callIntMethod(result, IDX_GetFaceRect, agfr);
		
		System.out.println("GetFaceRect rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(agfr.getLastError()));
		
		if (agfr.getLastError() < 0) throw new Exception_KINECT("GetFaceRect");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetFaceRect");

		return intRtn;
	}

	/*
	HRESULT Get2DShapePoints(
		FT_VECTOR2D** ppPoints,
		UINT* pPointCount
	)
	 */
	class Arg_Get2DShapePoints extends Arg_property {
		private Struct_REF_FT_VECTOR2D ppPoints = new Struct_REF_FT_VECTOR2D();
		private int[] pPointCount;
		
		Arg_Get2DShapePoints(int[] pPointCount) {
			this.pPointCount = pPointCount;
		}
		
		Struct_FT_VECTOR2D[] getPoints() {return this.ppPoints.pPoints;}
	}
	
	class Struct_REF_FT_VECTOR2D {
		@_Length_is("pPointCount") Struct_FT_VECTOR2D[] pPoints = null;
	}
	
	Struct_FT_VECTOR2D[] Get2DShapePoints(int[] pPointCount) throws Exception_KINECT {
		Arg_Get2DShapePoints ag2dsp = new Arg_Get2DShapePoints(pPointCount);

		int intRtn = JInvoker.callIntMethod(result, IDX_Get2DShapePoints, ag2dsp);
		
		System.out.println("Get2DShapePoints rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ag2dsp.getLastError()));
		
		if (ag2dsp.getLastError() < 0) throw new Exception_KINECT("Get2DShapePoints");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Get2DShapePoints");
		
		return ag2dsp.getPoints();
	}

	/*
	HRESULT Get3DPose(
		FLOAT *pScale,
		FLOAT rotationXYZ[3],
		FLOAT translationXYZ[3]
	)
	 */
	class Arg_Get3DPose extends Arg_property {
		private float[] pScale;
		private float[] rotationXYZ;
		private float[] translationXYZ;
		
		Arg_Get3DPose(float[] pScale, float[] rotationXYZ, float[] translationXYZ) {
			this.pScale = pScale;
			this.rotationXYZ = rotationXYZ;
			this.translationXYZ = translationXYZ;
		}
	}
	
	int Get3DPose(float[] pScale, float[] rotationXYZ, float[] translationXYZ) throws Exception_KINECT {
		Arg_Get3DPose ag3dp = new Arg_Get3DPose(pScale, rotationXYZ, translationXYZ);

		int intRtn = JInvoker.callIntMethod(result, IDX_Get3DPose, ag3dp);
		
		System.out.println("Get3DPose rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ag3dp.getLastError()));
		
		if (ag3dp.getLastError() < 0) throw new Exception_KINECT("Get3DPose");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Get3DPose");

		return intRtn;
	}

}
