package testkinect;

import utildll.*;

public class Wrp_INuiBackgroundRemovedColorStream {
	static final int CHARSET = Arg.UNICODE;
	long removeStream = 0;
	static final int 
		IDX_Release = 2,
		IDX_Enable = 3,
		IDX_SetTrackedPlayer = 4,
		IDX_ProcessDepth = 5,
		IDX_ProcessColor = 6,
		IDX_ProcessSkeleton = 7,
		IDX_GetNextFrame = 8,
		IDX_ReleaseFrame = 9,
		IDX_Disable = 10;
	
	Wrp_INuiBackgroundRemovedColorStream(long backStream) {
		this.removeStream = backStream;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT Enable(
	         NUI_IMAGE_RESOLUTION colorResolution,
	         NUI_IMAGE_RESOLUTION depthResolution,
	         HANDLE hNextFrameEvent
	)
	 */
	class Arg_Enable extends Arg_property {
		private int colorResolution;
		private int depthResolution;
		private long hNextFrameEvent;

		Arg_Enable(int colorResolution, int depthResolution, long hNextFrameEvent) {
			this.colorResolution = colorResolution;
			this.depthResolution = depthResolution;
			this.hNextFrameEvent = hNextFrameEvent;
		}
	}

	int Enable(int colorResolution, int depthResolution, long hNextFrameEvent) throws Exception_KINECT {
		Arg_Enable ae = new Arg_Enable(colorResolution, depthResolution, hNextFrameEvent);

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_Enable, ae);
		
		System.out.println("Enable rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ae.getLastError()));
		
		if (ae.getLastError() < 0) throw new Exception_KINECT("Enable");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Enable");

		return intRtn;
	}

	/*
	HRESULT SetTrackedPlayer(
	         DWORD trackingID
	)
	 */
	class Arg_SetTrackedPlayer extends Arg_property {
		private int trackingID;

		Arg_SetTrackedPlayer(int trackingID) {
			this.trackingID = trackingID;
		}
	}

	int SetTrackedPlayer(int trackingID) throws Exception_KINECT {
		Arg_SetTrackedPlayer astp = new Arg_SetTrackedPlayer(trackingID);

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_SetTrackedPlayer, astp);
		
		System.out.println("SetTrackedPlayer rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(astp.getLastError()));
		
		if (astp.getLastError() < 0) throw new Exception_KINECT("SetTrackedPlayer");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("SetTrackedPlayer");

		return intRtn;
	}

	/*
	HRESULT ProcessDepth(
	         UINT depthDataLength,
	         const BYTE *pDepthData,
	         LARGE_INTEGER liTimeStamp
	)
	 */
	class Arg_ProcessDepth extends Arg_property {
		private int depthDataLength;
		private long pDepthData; // const BYTE *
		private long liTimeStamp;

		Arg_ProcessDepth(int depthDataLength, long pDepthData, long liTimeStamp) {
			this.depthDataLength = depthDataLength;
			this.pDepthData = pDepthData;
			this.liTimeStamp = liTimeStamp;
		}
	}

	int ProcessDepth(int depthDataLength, long pDepthData, long liTimeStamp) throws Exception_KINECT {
		Arg_ProcessDepth apd = new Arg_ProcessDepth(depthDataLength, pDepthData, liTimeStamp);

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_ProcessDepth, apd);
		
		System.out.println("ProcessDepth rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(apd.getLastError()));
		
		if (apd.getLastError() < 0) throw new Exception_KINECT("ProcessDepth");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ProcessDepth");

		return intRtn;
	}
	
	/*
	HRESULT ProcessColor(
	         UINT colorDataLength,
	         const BYTE *pColorData,
	         LARGE_INTEGER liTimeStamp
	)
	 */
	class Arg_ProcessColor extends Arg_property {
		private int colorDataLength;
		private long pColorData; // const BYTE *
		private long liTimeStamp;

		Arg_ProcessColor(int colorDataLength, long pColorData, long liTimeStamp) {
			this.colorDataLength = colorDataLength;
			this.pColorData = pColorData;
			this.liTimeStamp = liTimeStamp;
		}
	}

	int ProcessColor(int colorDataLength, long pColorData, long liTimeStamp) throws Exception_KINECT {
		Arg_ProcessColor apc = new Arg_ProcessColor(colorDataLength, pColorData, liTimeStamp);

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_ProcessColor, apc);
		
		System.out.println("ProcessColor rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(apc.getLastError()));
		
		if (apc.getLastError() < 0) throw new Exception_KINECT("ProcessColor");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ProcessColor");

		return intRtn;
	}
	
	/*
	HRESULT ProcessSkeleton(
	         UINT skeletonCount,
	         const NUI_SKELETON_DATA *pSkeletonData,
	         LARGE_INTEGER liTimeStamp
	)
	 */
	class Arg_ProcessSkeleton extends Arg_property {
		private int skeletonCount;
		private @_Const Struct_NUI_SKELETON_DATA[] pSkeletonData;
		private long liTimeStamp;

		Arg_ProcessSkeleton(int skeletonCount, Struct_NUI_SKELETON_DATA[] pSkeletonData, long liTimeStamp) {
			this.skeletonCount = skeletonCount;
			this.pSkeletonData = pSkeletonData;
			this.liTimeStamp = liTimeStamp;
		}
	}

	int ProcessSkeleton(int skeletonCount, Struct_NUI_SKELETON_DATA[] pSkeletonData, long liTimeStamp)
			throws Exception_KINECT {
		Arg_ProcessSkeleton aps = new Arg_ProcessSkeleton(skeletonCount, pSkeletonData, liTimeStamp);

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_ProcessSkeleton, aps);
		
		System.out.println("ProcessSkeleton rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(aps.getLastError()));
		
		if (aps.getLastError() < 0) throw new Exception_KINECT("ProcessSkeleton");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ProcessSkeleton");

		return intRtn;
	}
	
	/*
	HRESULT GetNextFrame(
	         DWORD dwMillisecondsToWait,
	         NUI_BACKGROUND_REMOVED_COLOR_FRAME *pFrame
	)
	 */
	class Arg_GetNextFrame extends Arg_property {
		private int dwMillisecondsToWait;
		private Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME pFrame;

		Arg_GetNextFrame(int dwMillisecondsToWait, Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME pFrame) {
			this.dwMillisecondsToWait = dwMillisecondsToWait;
			this.pFrame = pFrame;
		}
	}

	int GetNextFrame(int dwMillisecondsToWait, Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME pFrame)
			throws Exception_KINECT {
		Arg_GetNextFrame agnf = new Arg_GetNextFrame(dwMillisecondsToWait, pFrame);

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_GetNextFrame, agnf);
		
		System.out.println("GetNextFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(agnf.getLastError()));
		
		if (agnf.getLastError() < 0) throw new Exception_KINECT("GetNextFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_NuiApi.E_NUI_FRAME_NO_DATA )
				throw new Exception_KINECT("GetNextFrame");

		return intRtn;
	}
	
	/*
	HRESULT ReleaseFrame(
	         const NUI_BACKGROUND_REMOVED_COLOR_FRAME *pFrame
	)
	 */
	class Arg_ReleaseFrame extends Arg_property {
		private @_Const Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME pFrame;

		Arg_ReleaseFrame(Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME pFrame) {
			this.pFrame = pFrame;
		}
	}

	int ReleaseFrame(Struct_NUI_BACKGROUND_REMOVED_COLOR_FRAME pFrame) throws Exception_KINECT {
		Arg_ReleaseFrame arf = new Arg_ReleaseFrame(pFrame);

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_ReleaseFrame, arf);
		
		System.out.println("ReleaseFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arf.getLastError()));
		
		if (arf.getLastError() < 0) throw new Exception_KINECT("ReleaseFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ReleaseFrame");

		return intRtn;
	}
	
	/*
	HRESULT Disable()
	 */
	class Arg_Disable extends Arg_property {
	}

	int Disable() throws Exception_KINECT {
		Arg_Disable ad = new Arg_Disable();

		int intRtn = JInvoker.callIntMethod(removeStream, IDX_Disable, ad);
		
		System.out.println("Disable rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ad.getLastError()));
		
		if (ad.getLastError() < 0) throw new Exception_KINECT("Disable");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Disable");

		return intRtn;
	}
	
}
