package testkinect;

import utildll.*;

public class Wrp_INuiFusionReconstruction {
	static final int CHARSET = Arg.UNICODE;
	long fusionReconst = 0;
	static final int 
		IDX_ResetReconstruction = 3,
		IDX_GetCurrentWorldToCameraTransform = 5,
		IDX_ProcessFrame = 8,
		IDX_CalculatePointCloud = 9;
	Wrp_INuiFusionReconstruction(long fusionReconst) {
		this.fusionReconst = fusionReconst;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	HRESULT ResetReconstruction(
	         const Matrix4 *pInitialWorldToCameraTransform,
	         const Matrix4 *pWorldToVolumeTransform
	)
	 */
	class Arg_ResetReconstruction extends Arg_property {
		private @_Const Struct_Matrix4 pInitialWorldToCameraTransform;
		private @_Const Struct_Matrix4 pWorldToVolumeTransform;

		Arg_ResetReconstruction(Struct_Matrix4 pInitialWorldToCameraTransform,
				Struct_Matrix4 pWorldToVolumeTransform) {
			this.pInitialWorldToCameraTransform = pInitialWorldToCameraTransform;
			this.pWorldToVolumeTransform = pWorldToVolumeTransform;
		}
	}

	int ResetReconstruction(Struct_Matrix4 pInitialWorldToCameraTransform,
			Struct_Matrix4 pWorldToVolumeTransform) throws Exception_KINECT {
		Arg_ResetReconstruction arr = new Arg_ResetReconstruction(pInitialWorldToCameraTransform,
				pWorldToVolumeTransform);

		int intRtn = JInvoker.callIntMethod(fusionReconst, IDX_ResetReconstruction, arr);
		
		System.out.println("ResetReconstruction rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(arr.getLastError()));
		
		if (arr.getLastError() < 0) throw new Exception_KINECT("ResetReconstruction");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ResetReconstruction");

		return intRtn;
	}

	/*
	HRESULT GetCurrentWorldToCameraTransform(
	         Matrix4 *pWorldToCameraTransform
	)
	 */
	class Arg_GetCurrentWorldToCameraTransform extends Arg_property {
		private Struct_Matrix4 pWorldToCameraTransform;

		Arg_GetCurrentWorldToCameraTransform(Struct_Matrix4 pWorldToCameraTransform) {
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	int GetCurrentWorldToCameraTransform(Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_GetCurrentWorldToCameraTransform agcwtct = new Arg_GetCurrentWorldToCameraTransform(
				pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(fusionReconst, IDX_GetCurrentWorldToCameraTransform, agcwtct);
		
		System.out.println("GetCurrentWorldToCameraTransform rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(agcwtct.getLastError()));
		
		if (agcwtct.getLastError() < 0) throw new Exception_KINECT("GetCurrentWorldToCameraTransform");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("GetCurrentWorldToCameraTransform");

		return intRtn;
	}
	
	/*
	HRESULT ProcessFrame(
	         const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
	         USHORT maxAlignIterationCount,
	         USHORT maxIntegrationWeight,
	         const Matrix4 *pWorldToCameraTransform
	)
	 */
	class Arg_ProcessFrame extends Arg_property {
		private long pDepthFloatFrame; // const NUI_FUSION_IMAGE_FRAME *
		private short maxAlignIterationCount;
		private short maxIntegrationWeight;
		private @_Const Struct_Matrix4 pWorldToCameraTransform;

		Arg_ProcessFrame(long pDepthFloatFrame, short maxAlignIterationCount,
				short maxIntegrationWeight,	Struct_Matrix4 pWorldToCameraTransform) {
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.maxAlignIterationCount = maxAlignIterationCount;
			this.maxIntegrationWeight = maxIntegrationWeight;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	int ProcessFrame(long pDepthFloatFrame, short maxAlignIterationCount,
			short maxIntegrationWeight,	Struct_Matrix4 pWorldToCameraTransform) throws Exception_KINECT {
		Arg_ProcessFrame apf = new Arg_ProcessFrame(pDepthFloatFrame, maxAlignIterationCount,
				maxIntegrationWeight, pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(fusionReconst, IDX_ProcessFrame, apf);
		
		System.out.println("ProcessFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(apf.getLastError()));
		
		if (apf.getLastError() < 0) throw new Exception_KINECT("ProcessFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_NuiKinectFusionApi.E_NUI_FUSION_TRACKING_ERROR)
				throw new Exception_KINECT("ProcessFrame");

		return intRtn;
	}
	
	/*
	HRESULT CalculatePointCloud(
		    const NUI_FUSION_IMAGE_FRAME *pPointCloudFrame,
		    const Matrix4 *pWorldToCameraTransform
	)
	 */
	class Arg_CalculatePointCloud extends Arg_property {
		private long pPointCloudFrame; // const NUI_FUSION_IMAGE_FRAME *
		private @_Const Struct_Matrix4 pWorldToCameraTransform;

		Arg_CalculatePointCloud(long pPointCloudFrame, Struct_Matrix4 pWorldToCameraTransform) {
			this.pPointCloudFrame = pPointCloudFrame;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
		}
	}

	int CalculatePointCloud(long pPointCloudFrame, Struct_Matrix4 pWorldToCameraTransform
			) throws Exception_KINECT {
		Arg_CalculatePointCloud acpc = new Arg_CalculatePointCloud(pPointCloudFrame,
				pWorldToCameraTransform);

		int intRtn = JInvoker.callIntMethod(fusionReconst, IDX_CalculatePointCloud, acpc);
		
		System.out.println("CalculatePointCloud rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(acpc.getLastError()));
		
		if (acpc.getLastError() < 0) throw new Exception_KINECT("CalculatePointCloud");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("CalculatePointCloud");

		return intRtn;
	}
}
