package testkinect;

import utildll.*;

public class Wrp_INuiInteractionStream {
	static final int CHARSET = Arg.UNICODE;
	long stream = 0;
	static final int
		IDX_Release = 2,
		IDX_Enable = 3,
		IDX_ProcessDepth = 4,
		IDX_ProcessSkeleton = 5,
		IDX_GetNextFrame = 6,
		IDX_Disable = 7;
	
	Wrp_INuiInteractionStream(long stream) {
		this.stream = stream;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(stream, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}
	
	/*
	HRESULT Enable(
		HANDLE hNextFrameEvent
	)
	 */
	class Arg_Enable extends Arg_property {
		private long hNextFrameEvent;
		
		Arg_Enable(long hNextFrameEvent) {
			this.hNextFrameEvent = hNextFrameEvent;
		}
	}
	
	int Enable(long hNextFrameEvent) throws Exception_KINECT {
		Arg_Enable ae = new Arg_Enable(hNextFrameEvent);

		int intRtn = JInvoker.callIntMethod(stream, IDX_Enable, ae);
		
		System.out.println("Enable rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ae.getLastError()));
		
		if (ae.getLastError() < 0) throw new Exception_KINECT("Enable");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Enable");

		return intRtn;
	}
	
	/*
	HRESULT ProcessDepth(
		UINT depthDataLength,
		BYTE *pDepthData,
		LARGE_INTEGER liTimeStamp
	)
	 */
	class Arg_ProcessDepth extends Arg_property {
		private int depthDataLength;
		private long pDepthData; // BYTE *
		private long liTimeStamp;
		
		Arg_ProcessDepth(int depthDataLength, long pDepthData, long liTimeStamp) {
			this.depthDataLength = depthDataLength;
			this.pDepthData = pDepthData;
			this.liTimeStamp = liTimeStamp;
		}
	}
	
	int ProcessDepth(int depthDataLength, long pDepthData, long liTimeStamp) throws Exception_KINECT {
		Arg_ProcessDepth apd = new Arg_ProcessDepth(depthDataLength, pDepthData, liTimeStamp);

		int intRtn = JInvoker.callIntMethod(stream, IDX_ProcessDepth, apd);
		
		System.out.println("ProcessDepth rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(apd.getLastError()));
		
		if (apd.getLastError() < 0) throw new Exception_KINECT("ProcessDepth");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ProcessDepth");

		return intRtn;
	}

	/*
	HRESULT ProcessSkeleton(
		UINT skeletonCount,
		NUI_SKELETON_DATA *pSkeletonData,
		Vector4 *pAccelerometerReading,
		LARGE_INTEGER liTimeStamp
	)
	 */
	class Arg_ProcessSkeleton extends Arg_property {
		private int skeletonCount;
		private Struct_NUI_SKELETON_DATA[] pSkeletonData;
		private Struct_Vector4 pAccelerometerReading;
		private long liTimeStamp;
		
		Arg_ProcessSkeleton(int skeletonCount, Struct_NUI_SKELETON_DATA[] pSkeletonData,
				Struct_Vector4 pAccelerometerReading, long liTimeStamp) {
			this.skeletonCount = skeletonCount;
			this.pSkeletonData = pSkeletonData;
			this.pAccelerometerReading = pAccelerometerReading;
			this.liTimeStamp = liTimeStamp;
		}
	}
	
	int ProcessSkeleton(int skeletonCount, Struct_NUI_SKELETON_DATA[] pSkeletonData,
			Struct_Vector4 pAccelerometerReading, long liTimeStamp) throws Exception_KINECT {
		Arg_ProcessSkeleton aps = new Arg_ProcessSkeleton(skeletonCount, pSkeletonData,
				pAccelerometerReading, liTimeStamp);

		int intRtn = JInvoker.callIntMethod(stream, IDX_ProcessSkeleton, aps);
		
		System.out.println("ProcessSkeleton rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(aps.getLastError()));
		
		if (aps.getLastError() < 0) throw new Exception_KINECT("ProcessSkeleton");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("ProcessSkeleton");

		return intRtn;
	}
	
	/*
	HRESULT GetNextFrame(
		DWORD dwMillisecondsToWait,
		NUI_INTERACTION_FRAME *pInteractionFrame
	)
	 */
	class Arg_GetNextFrame extends Arg_property {
		private int dwMillisecondsToWait;
		private Struct_NUI_INTERACTION_FRAME pInteractionFrame;
		
		Arg_GetNextFrame(int dwMillisecondsToWait, Struct_NUI_INTERACTION_FRAME pInteractionFrame) {
			this.dwMillisecondsToWait = dwMillisecondsToWait;
			this.pInteractionFrame = pInteractionFrame;
		}
	}
	
	int GetNextFrame(int dwMillisecondsToWait, Struct_NUI_INTERACTION_FRAME pInteractionFrame) throws Exception_KINECT {
		Arg_GetNextFrame agnf = new Arg_GetNextFrame(dwMillisecondsToWait, pInteractionFrame);

		int intRtn = JInvoker.callIntMethod(stream, IDX_GetNextFrame, agnf);
		
		System.out.println("GetNextFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(agnf.getLastError()));
		
		if (agnf.getLastError() < 0) throw new Exception_KINECT("GetNextFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_NuiApi.E_NUI_FRAME_NO_DATA )
				throw new Exception_KINECT("GetNextFrame");

		return intRtn;
	}

	/*
	HRESULT Disable()
	 */
	class Arg_Disable extends Arg_property {
	}
	
	int Disable() throws Exception_KINECT {
		Arg_Disable ad = new Arg_Disable();

		int intRtn = JInvoker.callIntMethod(stream, IDX_Disable, ad);
		
		System.out.println("Disable rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ad.getLastError()));
		
		if (ad.getLastError() < 0) throw new Exception_KINECT("Disable");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("Disable");

		return intRtn;
	}

}

