package testkinect;

import utildll.*;

class Wrp_INuiSensor {
	static final int CHARSET = Arg.UNICODE;
	long sensor = 0;
	static final int
			IDX_Release = 2, 
			IDX_NuiInitialize = 3, 
			IDX_NuiShutdown = 4,
			IDX_NuiSetFrameEndEvent = 5, 
			IDX_NuiImageStreamOpen = 6,
			IDX_NuiImageStreamSetImageFrameFlags = 7, 
			IDX_NuiImageStreamGetNextFrame = 9,
			IDX_NuiImageStreamReleaseFrame = 10,
			IDX_NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution = 12,
			IDX_NuiCameraElevationSetAngle = 14, 
			IDX_NuiCameraElevationGetAngle = 15,
			IDX_NuiSkeletonTrackingEnable = 16, 
			IDX_NuiSkeletonTrackingDisable = 17,
			IDX_NuiSkeletonGetNextFrame = 19,
			IDX_NuiStatus = 26,
			IDX_NuiGetCoordinateMapper = 28,
			IDX_NuiImageFrameGetDepthImagePixelFrameTexture = 29,
			IDX_NuiAccelerometerGetCurrentReading = 33;
	
	Wrp_INuiSensor(long sensor) {
		this.sensor = sensor;
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	ULONG Release()
	 */
	class Arg_Release extends Arg_property {
	}
	
	int Release() throws Exception_KINECT {
		Arg_Release ar = new Arg_Release();

		int intRtn = JInvoker.callIntMethod(sensor, IDX_Release, ar);
		
		System.out.println("Release rtn: " + Integer.toString(intRtn)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		if (ar.getLastError() < 0) throw new Exception_KINECT("Release");

		return intRtn;
	}

	/*
	HRESULT NuiInitialize(
		DWORD dwFlags
	)
	 */
	class Arg_NuiInitialize extends Arg_property {
		private int dwFlags;

		Arg_NuiInitialize(int dwFlags) {
			this.dwFlags = dwFlags;
		}
	}

	int NuiInitialize(int dwFlags) throws Exception_KINECT {
		Arg_NuiInitialize ani = new Arg_NuiInitialize(dwFlags);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiInitialize, ani);
		
		System.out.println("NuiInitialize rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ani.getLastError()));
		
		if (ani.getLastError() < 0) throw new Exception_KINECT("NuiInitialize");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiInitialize");

		return intRtn;
	}

	/*
	void NuiShutdown()
	 */
	class Arg_NuiShutdown extends Arg_property {
	}
	
	void NuiShutdown() throws Exception_KINECT {
		Arg_NuiShutdown ansd = new Arg_NuiShutdown();

		JInvoker.callVoidMethod(sensor, IDX_NuiShutdown, ansd);
		
		System.out.println("NuiShutdown LastError: " + Integer.toString(ansd.getLastError()));

		if (ansd.getLastError() < 0) throw new Exception_KINECT("NuiShutdown");
	}
	
	/*
	HRESULT NuiSetFrameEndEvent(
		 HANDLE hEvent,
		 DWORD dwFrameEventFlag
	)
	 */
	class Arg_NuiSetFrameEndEvent extends Arg_property {
		private long hEvent;
		private int dwFrameEventFlag;

		Arg_NuiSetFrameEndEvent(long hEvent, int dwFrameEventFlag) {
			this.hEvent = hEvent;
			this.dwFrameEventFlag = dwFrameEventFlag;
		}
	}

	int NuiSetFrameEndEvent(long hEvent, int dwFrameEventFlag) throws Exception_KINECT {
		Arg_NuiSetFrameEndEvent ansfee = new Arg_NuiSetFrameEndEvent(hEvent, dwFrameEventFlag);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiSetFrameEndEvent, ansfee);
		
		System.out.println("NuiSetFrameEndEvent rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ansfee.getLastError()));
		
		if (ansfee.getLastError() < 0) throw new Exception_KINECT("NuiSetFrameEndEvent");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiSetFrameEndEvent");

		return intRtn;
	}
	
	/*
	HRESULT NuiImageStreamOpen(
		 NUI_IMAGE_TYPE eImageType,
		 NUI_IMAGE_RESOLUTION eResolution,
		 DWORD dwImageFrameFlags,
		 DWORD dwFrameLimit,
		 HANDLE hNextFrameEvent,
		 HANDLE *phStreamHandle
	)
	 */
	class Arg_NuiImageStreamOpen extends Arg_property {
		private int eImageType;
		private int eResolution;
		private int dwImageFrameFlags;
		private int dwFrameLimit;
		private long hNextFrameEvent;
		private long[] phStreamHandle;

		Arg_NuiImageStreamOpen(int eImageType, int eResolution, int dwImageFrameFlags,
				int dwFrameLimit, long hNextFrameEvent, long[] phStreamHandle) {
			this.eImageType = eImageType;
			this.eResolution = eResolution;
			this.dwImageFrameFlags = dwImageFrameFlags;
			this.dwFrameLimit = dwFrameLimit;
			this.hNextFrameEvent = hNextFrameEvent;
			this.phStreamHandle = phStreamHandle;
		}
	}

	int NuiImageStreamOpen(int eImageType, int eResolution, int dwImageFrameFlags,
			int dwFrameLimit, long hNextFrameEvent, long[] phStreamHandle) throws Exception_KINECT {
		Arg_NuiImageStreamOpen aniso = new Arg_NuiImageStreamOpen(eImageType, eResolution,
				dwImageFrameFlags, dwFrameLimit, hNextFrameEvent, phStreamHandle);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiImageStreamOpen, aniso);
		
		System.out.println("NuiImageStreamOpen rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(aniso.getLastError()));
		
		if (aniso.getLastError() < 0) throw new Exception_KINECT("NuiImageStreamOpen");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiImageStreamOpen");

		return intRtn;
	}
	
	/*
	HRESULT NuiImageStreamSetImageFrameFlags(
	         HANDLE hStream,
	         DWORD dwImageFrameFlags
	)
	 */
	class Arg_NuiImageStreamSetImageFrameFlags extends Arg_property {
		private long hStream;
		private int dwImageFrameFlags;

		Arg_NuiImageStreamSetImageFrameFlags(long hStream, int dwImageFrameFlags) {
			this.hStream = hStream;
			this.dwImageFrameFlags = dwImageFrameFlags;
		}
	}

	int NuiImageStreamSetImageFrameFlags(long hStream, int dwImageFrameFlags) throws Exception_KINECT {
		Arg_NuiImageStreamSetImageFrameFlags anissiff = new Arg_NuiImageStreamSetImageFrameFlags(
				hStream, dwImageFrameFlags);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiImageStreamSetImageFrameFlags, anissiff);
		
		System.out.println("NuiImageStreamSetImageFrameFlags rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anissiff.getLastError()));
		
		if (anissiff.getLastError() < 0) throw new Exception_KINECT("NuiImageStreamSetImageFrameFlags");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiImageStreamSetImageFrameFlags");

		return intRtn;
	}
	
	/*
	HRESULT NuiImageStreamGetNextFrame(
	         HANDLE hStream,
	         DWORD dwMillisecondsToWait,
	         NUI_IMAGE_FRAME *pImageFrame
	)
	 */
	class Arg_NuiImageStreamGetNextFrame extends Arg_property {
		private long hStream;
		private int dwMillisecondsToWait;
		private Struct_NUI_IMAGE_FRAME pImageFrame;

		Arg_NuiImageStreamGetNextFrame(long hStream, int dwMillisecondsToWait,
				Struct_NUI_IMAGE_FRAME pImageFrame) {
			this.hStream = hStream;
			this.dwMillisecondsToWait = dwMillisecondsToWait;
			this.pImageFrame = pImageFrame;
		}
	}

	int NuiImageStreamGetNextFrame(long hStream, int dwMillisecondsToWait,
			Struct_NUI_IMAGE_FRAME pImageFrame) throws Exception_KINECT {
		Arg_NuiImageStreamGetNextFrame anisgnf = new Arg_NuiImageStreamGetNextFrame(hStream,
				dwMillisecondsToWait, pImageFrame);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiImageStreamGetNextFrame, anisgnf);
		
		System.out.println("NuiImageStreamGetNextFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anisgnf.getLastError()));
		
		if (anisgnf.getLastError() < 0) throw new Exception_KINECT("NuiImageStreamGetNextFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiImageStreamGetNextFrame");

		return intRtn;
	}
	
	/*
	HRESULT NuiImageStreamReleaseFrame(
	         HANDLE hStream,
	         NUI_IMAGE_FRAME *pImageFrame
	)
	 */
	class Arg_NuiImageStreamReleaseFrame extends Arg_property {
		private long hStream;
		private Struct_NUI_IMAGE_FRAME pImageFrame;

		Arg_NuiImageStreamReleaseFrame(long hStream, Struct_NUI_IMAGE_FRAME pImageFrame) {
			this.hStream = hStream;
			this.pImageFrame = pImageFrame;
		}
	}

	int NuiImageStreamReleaseFrame(long hStream, Struct_NUI_IMAGE_FRAME pImageFrame)
			throws Exception_KINECT {
		Arg_NuiImageStreamReleaseFrame anisrf = new Arg_NuiImageStreamReleaseFrame(hStream,	pImageFrame);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiImageStreamReleaseFrame, anisrf);
		
		System.out.println("NuiImageStreamReleaseFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anisrf.getLastError()));
		
		if (anisrf.getLastError() < 0) throw new Exception_KINECT("NuiImageStreamReleaseFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiImageStreamReleaseFrame");

		return intRtn;
	}
	
	/*
	HRESULT NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution(
		 NUI_IMAGE_RESOLUTION eColorResolution,
		 NUI_IMAGE_RESOLUTION eDepthResolution,
		 const NUI_IMAGE_VIEW_AREA *pcViewArea,
		 LONG lDepthX,
		 LONG lDepthY,
		 USHORT usDepthValue,
		 LONG *plColorX,
		 LONG *plColorY
	)
	 */
	class Arg_NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution extends Arg_property {
		private int eColorResolution;
		private int eDepthResolution;
		private @_Const Struct_NUI_IMAGE_VIEW_AREA pcViewArea;
		private int lDepthX;
		private int lDepthY;
		private short usDepthValue;
		private int[] plColorX;
		private int[] plColorY;
		

		Arg_NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution(
				int eColorResolution, int eDepthResolution, Struct_NUI_IMAGE_VIEW_AREA pcViewArea,
				int lDepthX, int lDepthY, short usDepthValue, int[] plColorX, int[] plColorY) {
			this.eColorResolution = eColorResolution;
			this.eDepthResolution = eDepthResolution;
			this.pcViewArea = pcViewArea;
			this.lDepthX = lDepthX;
			this.lDepthY = lDepthY;
			this.usDepthValue = usDepthValue;
			this.plColorX = plColorX;
			this.plColorY = plColorY;
		}
	}

	int NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution(
			int eColorResolution, int eDepthResolution, Struct_NUI_IMAGE_VIEW_AREA pcViewArea,
			int lDepthX, int lDepthY, short usDepthValue, int[] plColorX, int[] plColorY)
			throws Exception_KINECT {
		Arg_NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution anigcpcfdpar 
			= new Arg_NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution(
					eColorResolution, eDepthResolution, pcViewArea, lDepthX, lDepthY,
					usDepthValue, plColorX, plColorY);

		int intRtn = JInvoker.callIntMethod(sensor,
				IDX_NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution, anigcpcfdpar);
		/*
		System.out.println("NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution rtn: "
				+ Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anigcpcfdpar.getLastError()));
		*/
		if (anigcpcfdpar.getLastError() < 0)
			throw new Exception_KINECT("NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution");
		if (H_WinError.FAILED(intRtn))
			throw new Exception_KINECT("NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution");

		return intRtn;
	}
	
	/*
	HRESULT NuiCameraElevationSetAngle(
	         LONG lAngleDegrees
	)
	 */
	class Arg_NuiCameraElevationSetAngle extends Arg_property {
		private int lAngleDegrees;

		Arg_NuiCameraElevationSetAngle(int lAngleDegrees) {
			this.lAngleDegrees = lAngleDegrees;
		}
	}

	int NuiCameraElevationSetAngle(int lAngleDegrees) throws Exception_KINECT {
		Arg_NuiCameraElevationSetAngle ancesa = new Arg_NuiCameraElevationSetAngle(lAngleDegrees);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiCameraElevationSetAngle, ancesa);
		
		System.out.println("NuiCameraElevationSetAngle rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ancesa.getLastError()));
		
		if (ancesa.getLastError() < 0) throw new Exception_KINECT("NuiCameraElevationSetAngle");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiCameraElevationSetAngle");

		return intRtn;
	}
	
	/*
	HRESULT NuiCameraElevationGetAngle(
	         LONG *plAngleDegrees
	)
	 */
	class Arg_NuiCameraElevationGetAngle extends Arg_property {
		private int[] plAngleDegrees;

		Arg_NuiCameraElevationGetAngle(int[] plAngleDegrees) {
			this.plAngleDegrees = plAngleDegrees;
		}
	}

	int NuiCameraElevationGetAngle(int[] plAngleDegrees) throws Exception_KINECT {
		Arg_NuiCameraElevationGetAngle ancega = new Arg_NuiCameraElevationGetAngle(plAngleDegrees);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiCameraElevationGetAngle, ancega);
		
		System.out.println("NuiCameraElevationGetAngle rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ancega.getLastError()));
		
		if (ancega.getLastError() < 0) throw new Exception_KINECT("NuiCameraElevationGetAngle");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiCameraElevationGetAngle");

		return intRtn;
	}
	
	/*
	HRESULT NuiSkeletonTrackingEnable(
	         HANDLE hNextFrameEvent,
	         DWORD dwFlags
	)
	 */
	class Arg_NuiSkeletonTrackingEnable extends Arg_property {
		private long hNextFrameEvent;
		private int dwFlags;

		Arg_NuiSkeletonTrackingEnable(long hNextFrameEvent, int dwFlags) {
			this.hNextFrameEvent = hNextFrameEvent;
			this.dwFlags = dwFlags;
		}
	}

	int NuiSkeletonTrackingEnable(long hNextFrameEvent, int dwFlags) throws Exception_KINECT {
		Arg_NuiSkeletonTrackingEnable anste = new Arg_NuiSkeletonTrackingEnable(
				hNextFrameEvent, dwFlags);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiSkeletonTrackingEnable, anste);
		
		System.out.println("NuiSkeletonTrackingEnable rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anste.getLastError()));
		
		if (anste.getLastError() < 0) throw new Exception_KINECT("NuiSkeletonTrackingEnable");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiSkeletonTrackingEnable");

		return intRtn;
	}
	
	/*
	HRESULT NuiSkeletonTrackingDisable(
	         void
	)
	 */
	class Arg_NuiSkeletonTrackingDisable extends Arg_property {
	}
	
	int NuiSkeletonTrackingDisable() throws Exception_KINECT {
		Arg_NuiSkeletonTrackingDisable anstd = new Arg_NuiSkeletonTrackingDisable();

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiSkeletonTrackingDisable, anstd);
		
		System.out.println("NuiSkeletonTrackingDisable rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anstd.getLastError()));
		
		if (anstd.getLastError() < 0) throw new Exception_KINECT("NuiSkeletonTrackingDisable");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiSkeletonTrackingDisable");

		return intRtn;
	}
	
	/*
	HRESULT NuiSkeletonGetNextFrame(
	         DWORD dwMillisecondsToWait,
	         NUI_SKELETON_FRAME *pSkeletonFrame
	)
	 */
	class Arg_NuiSkeletonGetNextFrame extends Arg_property {
		private int dwMillisecondsToWait;
		private Struct_NUI_SKELETON_FRAME pSkeletonFrame;

		Arg_NuiSkeletonGetNextFrame(int dwMillisecondsToWait, Struct_NUI_SKELETON_FRAME pSkeletonFrame) {
			this.dwMillisecondsToWait = dwMillisecondsToWait;
			this.pSkeletonFrame = pSkeletonFrame;
		}
	}

	int NuiSkeletonGetNextFrame(int dwMillisecondsToWait, Struct_NUI_SKELETON_FRAME pSkeletonFrame)
			 throws Exception_KINECT {
		Arg_NuiSkeletonGetNextFrame ansgnf = new Arg_NuiSkeletonGetNextFrame(
				dwMillisecondsToWait, pSkeletonFrame);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiSkeletonGetNextFrame, ansgnf);
		
		System.out.println("NuiSkeletonGetNextFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ansgnf.getLastError()));
		
		if (ansgnf.getLastError() < 0) throw new Exception_KINECT("NuiSkeletonGetNextFrame");
		if (H_WinError.FAILED(intRtn))
			if (intRtn != H_NuiApi.E_NUI_FRAME_NO_DATA )
				throw new Exception_KINECT("NuiSkeletonGetNextFrame");

		return intRtn;
	}
	
	/*
	HRESULT NuiStatus()
	 */
	class Arg_NuiStatus extends Arg_property {
	}
	
	int NuiStatus() throws Exception_KINECT {
		Arg_NuiStatus ans = new Arg_NuiStatus();

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiStatus, ans);
		
		System.out.println("NuiStatus rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ans.getLastError()));
		
		if (ans.getLastError() < 0) throw new Exception_KINECT("NuiStatus");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiStatus");

		return intRtn;
	}
	
	/*
	HRESULT NuiGetCoordinateMapper(
	         INuiCoordinateMapper **pMapping
	)
	 */
	class Arg_NuiGetCoordinateMapper extends Arg_property {
		private long[] pMapping; // INuiCoordinateMapper **

		Arg_NuiGetCoordinateMapper(long[] pMapping) {
			this.pMapping = pMapping;
		}
	}

	int NuiGetCoordinateMapper(long[] pMapping) throws Exception_KINECT {
		Arg_NuiGetCoordinateMapper angcm = new Arg_NuiGetCoordinateMapper(pMapping);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiGetCoordinateMapper, angcm);
		
		System.out.println("NuiGetCoordinateMapper rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(angcm.getLastError()));
		
		if (angcm.getLastError() < 0) throw new Exception_KINECT("NuiGetCoordinateMapper");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiGetCoordinateMapper");

		return intRtn;
	}
	
	/*
	HRESULT NuiImageFrameGetDepthImagePixelFrameTexture(
	         HANDLE hStream,
	         NUI_IMAGE_FRAME *pImageFrame,
	         BOOL *pNearMode,
	         INuiFrameTexture **ppFrameTexture
	)
	 */
	class Arg_NuiImageFrameGetDepthImagePixelFrameTexture extends Arg_property {
		private long hStream;
		private Struct_NUI_IMAGE_FRAME pImageFrame;
		private boolean[] pNearMode;
		private long[] ppFrameTexture; // INuiFrameTexture **

		Arg_NuiImageFrameGetDepthImagePixelFrameTexture(long hStream, Struct_NUI_IMAGE_FRAME pImageFrame,
				boolean[] pNearMode, long[] ppFrameTexture) {
			this.hStream = hStream;
			this.pImageFrame = pImageFrame;
			this.pNearMode = pNearMode;
			this.ppFrameTexture = ppFrameTexture;
		}
	}

	int NuiImageFrameGetDepthImagePixelFrameTexture(long hStream, Struct_NUI_IMAGE_FRAME pImageFrame,
			boolean[] pNearMode, long[] ppFrameTexture) throws Exception_KINECT {
		Arg_NuiImageFrameGetDepthImagePixelFrameTexture anifgdipft = new Arg_NuiImageFrameGetDepthImagePixelFrameTexture(
				hStream, pImageFrame, pNearMode, ppFrameTexture);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiImageFrameGetDepthImagePixelFrameTexture, anifgdipft);
		
		System.out.println("NuiImageFrameGetDepthImagePixelFrameTexture rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anifgdipft.getLastError()));
		
		if (anifgdipft.getLastError() < 0) throw new Exception_KINECT("NuiImageFrameGetDepthImagePixelFrameTexture");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiImageFrameGetDepthImagePixelFrameTexture");

		return intRtn;
	}
	
	/*
	HRESULT NuiAccelerometerGetCurrentReading(
	         Vector4 *pReading
	)
	 */
	class Arg_NuiAccelerometerGetCurrentReading extends Arg_property {
		private Struct_Vector4 pReading;

		Arg_NuiAccelerometerGetCurrentReading(Struct_Vector4 pReading) {
			this.pReading = pReading;
		}
	}

	int NuiAccelerometerGetCurrentReading(Struct_Vector4 pReading) throws Exception_KINECT {
		Arg_NuiAccelerometerGetCurrentReading anagcr = new Arg_NuiAccelerometerGetCurrentReading(pReading);

		int intRtn = JInvoker.callIntMethod(sensor, IDX_NuiAccelerometerGetCurrentReading, anagcr);
		
		System.out.println("NuiAccelerometerGetCurrentReading rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anagcr.getLastError()));
		
		if (anagcr.getLastError() < 0) throw new Exception_KINECT("NuiAccelerometerGetCurrentReading");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiAccelerometerGetCurrentReading");

		return intRtn;
	}

}
