package testkinect;

import utildll.*;

public class Wrp_JInvoker {
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	class Arg_allocFunc extends Arg_property {
		private @_FuncPtr Object obj;
		
		Arg_allocFunc(Object obj) {
			this.obj = obj;
		}
	}
	
	long allocFunc(Object obj) throws Exception_JInvoker {
		Arg_allocFunc aao = new Arg_allocFunc(obj);
		
		long adrs = JInvoker.allocObject(aao);
		
		System.out.println("allocFunc allocAdrs: " + Long.toHexString(adrs)
				+ " LastError: " + Integer.toString(aao.getLastError()));
		
		if (aao.getLastError() != 0) throw new Exception_JInvoker("allocFunc");
		
		return adrs;
	}

	class Arg_allocStruct extends Arg_property {
		private Object obj;
		
		Arg_allocStruct(Object obj) {
			this.obj = obj;
		}
	}
	
	long allocStruct(Object obj) throws Exception_JInvoker {
		Arg_allocStruct aas = new Arg_allocStruct(obj);
		
		long adrs = JInvoker.allocObject(aas);
		
		System.out.println("allocStruct allocAdrs: " + Long.toHexString(adrs)
				+ " LastError: " + Integer.toString(aas.getLastError()));
		
		if (aas.getLastError() != 0) throw new Exception_JInvoker("allocStruct");
		
		return adrs;
	}

	int freeObject(long adrs) {
		int intRtnVal = JInvoker.freeObject(adrs);
		
		System.out.println("freeObject intRtnVal: " + Integer.toString(intRtnVal));

		return intRtnVal;
	}
	
	class Arg_movePtrToStruct extends Arg_property {
		private Object obj;
		
		Arg_movePtrToStruct(Object obj) {
			this.obj = obj;
		}
	}

	int movePtrToStruct(Object obj, long ptr) throws Exception_JInvoker {
		Arg_movePtrToStruct ampts = new Arg_movePtrToStruct(obj);
		
		int intRtn = JInvoker.movePtrToObject(ampts, ptr);
		
		System.out.println("movePtrToStruct rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ampts.getLastError()));
		
		if (ampts.getLastError() != 0) throw new Exception_JInvoker("movePtrToStruct");

		return intRtn;
	}
	
	class Arg_sizeof extends Arg_property {
		private @_Const Object obj;

		Arg_sizeof(Object obj) {
			this.obj = obj;
		}
	}

	public long sizeof(Object obj) throws Exception_JInvoker {
		Arg_sizeof aso = new Arg_sizeof(obj);
		
		long lngSize = JInvoker.sizeof(aso);
		
		System.out.println("sizeof rtn: " + Long.toString(lngSize)
				+ " LastError: " + Integer.toString(aso.getLastError()));
		
		if (aso.getLastError() != 0) throw new Exception_JInvoker("sizeof");
		
		return lngSize;
	}

	class Arg_movePtrToByteArray extends Arg_property {
		private byte[] ab;
		
		Arg_movePtrToByteArray(byte[] ab) {
			this.ab = ab;
		}
	}

	int movePtrToByteArray(byte[] ab, long ptr) throws Exception_JInvoker {
		Arg_movePtrToByteArray amptba = new Arg_movePtrToByteArray(ab);
		
		int intRtn = JInvoker.movePtrToObject(amptba, ptr);
		
		System.out.println("movePtrToByteArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(amptba.getLastError()));
		
		if (amptba.getLastError() != 0) throw new Exception_JInvoker("movePtrToByteArray");
		
		return intRtn;
	}

	class Arg_movePtrToIntArray extends Arg_property {
		private int[] ai;
		
		Arg_movePtrToIntArray(int[] ai) {
			this.ai = ai;
		}
	}

	int movePtrToIntArray(int[] ai, long ptr) throws Exception_JInvoker {
		Arg_movePtrToIntArray amptia = new Arg_movePtrToIntArray(ai);
		
		int intRtn = JInvoker.movePtrToObject(amptia, ptr);
		
		System.out.println("movePtrToIntArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(amptia.getLastError()));
		
		if (amptia.getLastError() != 0) throw new Exception_JInvoker("movePtrToIntArray");

		return intRtn;
	}

	class Arg_movePtrToShortArray extends Arg_property {
		private short[] as;
		
		Arg_movePtrToShortArray(short[] as) {
			this.as = as;
		}
	}

	int movePtrToShortArray(short[] as, long ptr) throws Exception_JInvoker {
		Arg_movePtrToShortArray amptsa = new Arg_movePtrToShortArray(as);
		
		int intRtn = JInvoker.movePtrToObject(amptsa, ptr);
		
		System.out.println("movePtrToShortArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(amptsa.getLastError()));
		
		if (amptsa.getLastError() != 0) throw new Exception_JInvoker("movePtrToShortArray");

		return intRtn;
	}

	class Arg_movePtrToFloatArray extends Arg_property {
		private float[] af;
		
		Arg_movePtrToFloatArray(float[] af) {
			this.af = af;
		}
	}

	int movePtrToFloatArray(float[] af, long ptr) throws Exception_JInvoker {
		Arg_movePtrToFloatArray amptfa = new Arg_movePtrToFloatArray(af);
		
		int intRtn = JInvoker.movePtrToObject(amptfa, ptr);
		
		System.out.println("movePtrToFloatArray rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(amptfa.getLastError()));
		
		if (amptfa.getLastError() != 0) throw new Exception_JInvoker("movePtrToFloatArray");

		return intRtn;
	}

	class Arg_moveIntArrayToPtr extends Arg_property {
		private int[] ai;
		
		Arg_moveIntArrayToPtr(int[] ai) {
			this.ai = ai;
		}
	}

	int moveIntArrayToPtr(long ptr, int[] ai) throws Exception_JInvoker {
		Arg_moveIntArrayToPtr amiatp = new Arg_moveIntArrayToPtr(ai);
		
		int intRtn = JInvoker.moveObjectToPtr(ptr, amiatp);
		
		System.out.println("moveIntArrayToPtr rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(amiatp.getLastError()));
		
		if (amiatp.getLastError() != 0) throw new Exception_JInvoker("moveIntArrayToPtr");

		return intRtn;
	}


}
