package testkinect;

import utildll.*;

class Wrp_KINECT {
	static final int CHARSET = Arg.UNICODE;
	static final String KINECT_DLL_NAME = "kinect10";
	private String[] strFncName = {
			"NuiGetSensorCount",
			"NuiCreateSensorByIndex"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_NuiGetSensorCount = 0,
			IDX_NuiCreateSensorByIndex = 1;
	private long hMod = 0;
	
	Wrp_KINECT() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(KINECT_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " strFncName: " + strFncName[i]);
		}
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT NuiGetSensorCount(
		int *pCount
	)
	 */
	class Arg_NuiGetSensorCount extends Arg_property {
		private int[] pCount;

		Arg_NuiGetSensorCount(int[] pCount) {
			this.pCount = pCount;
		}
	}
	
	int NuiGetSensorCount(int[] pCount) throws Exception_KINECT {
		Arg_NuiGetSensorCount angsc = new Arg_NuiGetSensorCount(pCount);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiGetSensorCount], angsc);
		
		System.out.println("NuiGetSensorCount rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(angsc.getLastError()));
		
		if (angsc.getLastError() < 0) throw new Exception_KINECT("NuiGetSensorCount");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiGetSensorCount");
		
		return intRtn;
	}
	
	/*
	HRESULT NuiCreateSensorByIndex(
		int index,
		INuiSensor **ppNuiSensor
	)
	 */
	class Arg_NuiCreateSensorByIndex extends Arg_property {
		private int index;
		private long[] ppNuiSensor; // INuiSensor **

		Arg_NuiCreateSensorByIndex(int index, long[] ppNuiSensor) {
			this.index = index;
			this.ppNuiSensor = ppNuiSensor;
		}
	}
	
	int NuiCreateSensorByIndex(int index, long[] ppNuiSensor) throws Exception_KINECT {
		Arg_NuiCreateSensorByIndex ancsbi = new Arg_NuiCreateSensorByIndex(index, ppNuiSensor);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiCreateSensorByIndex], ancsbi);
		
		System.out.println("NuiCreateSensorByIndex rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ancsbi.getLastError()));
		
		if (ancsbi.getLastError() < 0) throw new Exception_KINECT("NuiCreateSensorByIndex");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiCreateSensorByIndex");

		return intRtn;
	}

	void NuiImageResolutionToSize(int res, int[] refWidth, int[] refHeight)
	{
	    switch( res )
	    {
	    case H_NuiImageCamera.NUI_IMAGE_RESOLUTION_80x60:
	        refWidth[0] = 80;
	        refHeight[0] = 60;
	        break;
	    case H_NuiImageCamera.NUI_IMAGE_RESOLUTION_320x240:
	        refWidth[0] = 320;
	        refHeight[0] = 240;
	        break;
	    case H_NuiImageCamera.NUI_IMAGE_RESOLUTION_640x480:
	        refWidth[0] = 640;
	        refHeight[0] = 480;
	        break;
	    case H_NuiImageCamera.NUI_IMAGE_RESOLUTION_1280x960 :
	        refWidth[0] = 1280;
	        refHeight[0] = 960;
	        break;
	    default:
	        refWidth[0] = 0;
	        refHeight[0] = 0;
	        break;
	    }
	}

	int NuiDepthPixelToDepth(short packedPixel) {
		return ((int)packedPixel & 0xffff) >> H_NuiImageCamera.NUI_IMAGE_PLAYER_INDEX_SHIFT;
	}

	int NuiDepthPixelToPlayerIndex(short packedPixel) {
		return (int)packedPixel & H_NuiImageCamera.NUI_IMAGE_PLAYER_INDEX_MASK;
	}

	void NuiTransformSkeletonToDepthImage(Struct_Vector4 vPoint, float[] pfDepthX, float[] pfDepthY,
			int eResolution) {
	    if((pfDepthX == null) || (pfDepthY == null)) {
	        return;
	    }
	    if(vPoint.z > H_NuiSkeleton.FLT_EPSILON) {
	        int[] width = {0};
	        int[] height = {0};
	        NuiImageResolutionToSize(eResolution, width, height);

	        pfDepthX[0] = (float)width[0]  / 2 + vPoint.x * ((float)width[0] /320.f)
	        		* H_NuiSkeleton.NUI_CAMERA_SKELETON_TO_DEPTH_IMAGE_MULTIPLIER_320x240 / vPoint.z;
	        pfDepthY[0] = (float)height[0] / 2 - vPoint.y * ((float)height[0]/240.f)
	        		* H_NuiSkeleton.NUI_CAMERA_SKELETON_TO_DEPTH_IMAGE_MULTIPLIER_320x240 / vPoint.z;
	    }
	    else {
	    	pfDepthX[0] = 0.0f;
	    	pfDepthY[0] = 0.0f;
	    }
	}
	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}
	
}
