package testkinect;

import utildll.*;

class Wrp_KinectFusion {
	static final int CHARSET = Arg.UNICODE;
	static final String FUSION_DLL_NAME = "KinectFusion180_64";
	private String[] strFncName = {
			"NuiFusionAlignPointClouds",
			"NuiFusionCreateCameraPoseFinder",
			"NuiFusionCreateColorReconstruction",
			"NuiFusionCreateImageFrame",
			"NuiFusionCreateReconstruction",
			"NuiFusionDepthFloatFrameToPointCloud",
			"NuiFusionDepthToDepthFloatFrame",
			"NuiFusionGetDeviceInfo",
			"NuiFusionReleaseImageFrame",
			"NuiFusionShadePointCloud"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_NuiFusionAlignPointClouds = 0,
			IDX_NuiFusionCreateCameraPoseFinder = 1,
			IDX_NuiFusionCreateColorReconstruction = 2,
			IDX_NuiFusionCreateImageFrame = 3,
			IDX_NuiFusionCreateReconstruction = 4,
			IDX_NuiFusionDepthFloatFrameToPointCloud = 5,
			IDX_NuiFusionDepthToDepthFloatFrame = 6,
			IDX_NuiFusionGetDeviceInfo = 7,
			IDX_NuiFusionReleaseImageFrame = 8,
			IDX_NuiFusionShadePointCloud = 9;
	private long hMod = 0;
	
	Wrp_KinectFusion() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(FUSION_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " strFncName: " + strFncName[i]);
		}
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT NuiFusionCreateColorReconstruction(
	         const NUI_FUSION_RECONSTRUCTION_PARAMETERS *pReconstructionParameters,
	         NUI_FUSION_RECONSTRUCTION_PROCESSOR_TYPE reconstructionProcessorType,
	         INT deviceIndex,
	         const Matrix4 *pInitialWorldToCameraTransform,
	         INuiFusionColorReconstruction **ppNuiFusionColorReconstruction
	)
	 */
	class Arg_NuiFusionCreateColorReconstruction extends Arg_property {
		private @_Const Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters;
		private int reconstructionProcessorType;
		private int deviceIndex;
		private @_Const Struct_Matrix4 pInitialWorldToCameraTransform;
		private long[] ppNuiFusionColorReconstruction; // INuiFusionColorReconstruction **

		Arg_NuiFusionCreateColorReconstruction(Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters,
				int reconstructionProcessorType, int deviceIndex, Struct_Matrix4 pInitialWorldToCameraTransform,
				long[] ppNuiFusionColorReconstruction) {
			this.pReconstructionParameters = pReconstructionParameters;
			this.reconstructionProcessorType = reconstructionProcessorType;
			this.deviceIndex = deviceIndex;
			this.pInitialWorldToCameraTransform = pInitialWorldToCameraTransform;
			this.ppNuiFusionColorReconstruction = ppNuiFusionColorReconstruction;
		}
	}
	
	int NuiFusionCreateColorReconstruction(Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters,
			int reconstructionProcessorType, int deviceIndex, Struct_Matrix4 pInitialWorldToCameraTransform,
			long[] ppNuiFusionColorReconstruction) throws Exception_KINECT {
		Arg_NuiFusionCreateColorReconstruction anfccr = new Arg_NuiFusionCreateColorReconstruction(
				pReconstructionParameters, reconstructionProcessorType, deviceIndex,
				pInitialWorldToCameraTransform, ppNuiFusionColorReconstruction);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionCreateColorReconstruction], anfccr);
		
		System.out.println("NuiFusionCreateColorReconstruction rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anfccr.getLastError()));
		
		if (anfccr.getLastError() < 0) throw new Exception_KINECT("NuiFusionCreateColorReconstruction");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionCreateColorReconstruction");
		
		return intRtn;
	}
	
	/*
	HRESULT NuiFusionCreateImageFrame(
		NUI_FUSION_IMAGE_TYPE frameType,
		UINT width,
		UINT height,
		const NUI_FUSION_CAMERA_PARAMETERS *pCameraParameters,
		NUI_FUSION_IMAGE_FRAME **ppImageFrame
	)
	 */
	class Arg_NuiFusionCreateImageFrame extends Arg_property {
		private int frameType;
		private int width;
		private int height;
		private @_Const Struct_NUI_FUSION_CAMERA_PARAMETERS pCameraParameters;
		private long[] ppImageFrame; // NUI_FUSION_IMAGE_FRAME **

		Arg_NuiFusionCreateImageFrame(int frameType, int width, int height,
				Struct_NUI_FUSION_CAMERA_PARAMETERS pCameraParameters, long[] ppImageFrame) {
			this.frameType = frameType;
			this.width = width;
			this.height = height;
			this.pCameraParameters = pCameraParameters;
			this.ppImageFrame = ppImageFrame;
		}
	}
	
	int NuiFusionCreateImageFrame(int frameType, int width, int height,
			Struct_NUI_FUSION_CAMERA_PARAMETERS pCameraParameters, long[] ppImageFrame) throws Exception_KINECT {
		Arg_NuiFusionCreateImageFrame anfcif = new Arg_NuiFusionCreateImageFrame(
				frameType, width, height, pCameraParameters, ppImageFrame);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionCreateImageFrame], anfcif);
		
		System.out.println("NuiFusionCreateImageFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anfcif.getLastError()));
		
		if (anfcif.getLastError() < 0) throw new Exception_KINECT("NuiFusionCreateImageFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionCreateImageFrame");
		
		return intRtn;
	}

	/*
	HRESULT NuiFusionCreateReconstruction(
		const NUI_FUSION_RECONSTRUCTION_PARAMETERS *pReconstructionParameters,
		NUI_FUSION_RECONSTRUCTION_PROCESSOR_TYPE reconstructionProcessorType,
		INT deviceIndex,
		const Matrix4 *pInitialWorldToCameraTransform,
		INuiFusionReconstruction **ppNuiFusionReconstruction
	)
	 */
	class Arg_NuiFusionCreateReconstruction extends Arg_property {
		private @_Const Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters;
		private int reconstructionProcessorType;
		private int deviceIndex;
		private @_Const Struct_Matrix4 pInitialWorldToCameraTransform;
		private long[] ppNuiFusionReconstruction; // INuiFusionReconstruction **

		Arg_NuiFusionCreateReconstruction(Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters,
				int reconstructionProcessorType, int deviceIndex, Struct_Matrix4 pInitialWorldToCameraTransform,
				long[] ppNuiFusionReconstruction) {
			this.pReconstructionParameters = pReconstructionParameters;
			this.reconstructionProcessorType = reconstructionProcessorType;
			this.deviceIndex = deviceIndex;
			this.pInitialWorldToCameraTransform = pInitialWorldToCameraTransform;
			this.ppNuiFusionReconstruction = ppNuiFusionReconstruction;
		}
	}
	
	int NuiFusionCreateReconstruction(Struct_NUI_FUSION_RECONSTRUCTION_PARAMETERS pReconstructionParameters,
			int reconstructionProcessorType, int deviceIndex, Struct_Matrix4 pInitialWorldToCameraTransform,
			long[] ppNuiFusionReconstruction) throws Exception_KINECT {
		Arg_NuiFusionCreateReconstruction anfcr = new Arg_NuiFusionCreateReconstruction(
				pReconstructionParameters, reconstructionProcessorType, deviceIndex,
				pInitialWorldToCameraTransform, ppNuiFusionReconstruction);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionCreateReconstruction], anfcr);
		
		System.out.println("NuiFusionCreateReconstruction rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anfcr.getLastError()));
		
		if (anfcr.getLastError() < 0) throw new Exception_KINECT("NuiFusionCreateReconstruction");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionCreateReconstruction");
		
		return intRtn;
	}

	/*
	HRESULT NuiFusionDepthToDepthFloatFrame(
		const NUI_DEPTH_IMAGE_PIXEL *pDepthImageData,
		UINT depthImageDataWidth,
		UINT depthImageDataHeight,
		const NUI_FUSION_IMAGE_FRAME *pDepthFloatFrame,
		FLOAT minDepthClip,
		FLOAT maxDepthClip,
		BOOL mirrorDepth
	)
	 */
	class Arg_NuiFusionDepthToDepthFloatFrame extends Arg_property {
		private long pDepthImageData; //const NUI_DEPTH_IMAGE_PIXEL *
		private int depthImageDataWidth;
		private int depthImageDataHeight;
		private long pDepthFloatFrame;  //const NUI_FUSION_IMAGE_FRAME *
		private float minDepthClip;
		private float maxDepthClip;
		private boolean mirrorDepth;

		Arg_NuiFusionDepthToDepthFloatFrame(long pDepthImageData, int depthImageDataWidth,
				int depthImageDataHeight, long pDepthFloatFrame, float minDepthClip,
				float maxDepthClip, boolean mirrorDepth) {
			this.pDepthImageData = pDepthImageData;
			this.depthImageDataWidth = depthImageDataWidth;
			this.depthImageDataHeight = depthImageDataHeight;
			this.pDepthFloatFrame = pDepthFloatFrame;
			this.minDepthClip = minDepthClip;
			this.maxDepthClip = maxDepthClip;
			this.mirrorDepth = mirrorDepth;
		}
	}
	
	int NuiFusionDepthToDepthFloatFrame(long pDepthImageData, int depthImageDataWidth,
			int depthImageDataHeight, long pDepthFloatFrame, float minDepthClip,
			float maxDepthClip, boolean mirrorDepth) throws Exception_KINECT {
		Arg_NuiFusionDepthToDepthFloatFrame anfdtdff = new Arg_NuiFusionDepthToDepthFloatFrame(
				pDepthImageData, depthImageDataWidth, depthImageDataHeight, pDepthFloatFrame, 
				minDepthClip, maxDepthClip, mirrorDepth);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionDepthToDepthFloatFrame], anfdtdff);
		
		System.out.println("NuiFusionDepthToDepthFloatFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anfdtdff.getLastError()));
		
		if (anfdtdff.getLastError() < 0) throw new Exception_KINECT("NuiFusionDepthToDepthFloatFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionDepthToDepthFloatFrame");
		
		return intRtn;
	}
	
	/*
	HRESULT FUSIONAPI NuiFusionGetDeviceInfo(
	         _NUI_FUSION_RECONSTRUCTION_PROCESSOR_TYPE type,
	         INT index,
	         PWSTR pDescription,
	         UINT descriptionSizeInChars,
	         PWSTR pInstancePath,
	         UINT instancePathSizeInChars,
	         UINT *pMemoryKB
	)
	 */
	class Arg_NuiFusionGetDeviceInfo extends Arg_property {
		private int type;
		private int index;
		private String pDescription;
		private int descriptionSizeInChars;
		private String pInstancePath;
		private int instancePathSizeInChars;
		private int[] pMemoryKB;

		Arg_NuiFusionGetDeviceInfo(int type, int index, String pDescription, int descriptionSizeInChars,
				String pInstancePath, int instancePathSizeInChars, int[] pMemoryKB) {
			this.type = type;
			this.index = index;
			this.pDescription = pDescription;
			this.descriptionSizeInChars = descriptionSizeInChars;
			this.pInstancePath = pInstancePath;
			this.instancePathSizeInChars = instancePathSizeInChars;
			this.pMemoryKB = pMemoryKB;
		}
	}
	
	int NuiFusionGetDeviceInfo(int type, int index, String pDescription, int descriptionSizeInChars,
			String pInstancePath, int instancePathSizeInChars, int[] pMemoryKB) throws Exception_KINECT {
		Arg_NuiFusionGetDeviceInfo anfgdi = new Arg_NuiFusionGetDeviceInfo(type, index,
				pDescription, descriptionSizeInChars, pInstancePath, instancePathSizeInChars, pMemoryKB);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionGetDeviceInfo], anfgdi);
		
		System.out.println("NuiFusionGetDeviceInfo rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anfgdi.getLastError()));
		
		if (anfgdi.getLastError() < 0) throw new Exception_KINECT("NuiFusionGetDeviceInfo");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionGetDeviceInfo");
		
		return intRtn;
	}
	
	/*
	HRESULT NuiFusionReleaseImageFrame(
	         NUI_FUSION_IMAGE_FRAME *pImageFrame
	)
	 */
	class Arg_NuiFusionReleaseImageFrame extends Arg_property {
		private long pImageFrame; // NUI_FUSION_IMAGE_FRAME *

		Arg_NuiFusionReleaseImageFrame(long pImageFrame) {
			this.pImageFrame = pImageFrame;
		}
	}
	
	int NuiFusionReleaseImageFrame(long pImageFrame) throws Exception_KINECT {
		Arg_NuiFusionReleaseImageFrame anfrif = new Arg_NuiFusionReleaseImageFrame(pImageFrame);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionReleaseImageFrame], anfrif);
		
		System.out.println("NuiFusionReleaseImageFrame rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anfrif.getLastError()));
		
		if (anfrif.getLastError() < 0) throw new Exception_KINECT("NuiFusionReleaseImageFrame");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionReleaseImageFrame");
		
		return intRtn;
	}
	
	/*
	HRESULT NuiFusionShadePointCloud(
		const NUI_FUSION_IMAGE_FRAME *pPointCloudFrame,
		const Matrix4 *pWorldToCameraTransform,
		const Matrix4 *pWorldToBGRTransform,
		const NUI_FUSION_IMAGE_FRAME *pShadedSurfaceFrame, 
		const NUI_FUSION_IMAGE_FRAME *pShadedSurfaceNormalsFrame
	)
	 */
	class Arg_NuiFusionShadePointCloud extends Arg_property {
		private long pPointCloudFrame;  // const NUI_FUSION_IMAGE_FRAME *
		private @_Const Struct_Matrix4 pWorldToCameraTransform;
		private @_Const Struct_Matrix4 pWorldToBGRTransform;
		private long pShadedSurfaceFrame;  // const NUI_FUSION_IMAGE_FRAME *
		private long pShadedSurfaceNormalsFrame;  // const NUI_FUSION_IMAGE_FRAME *

		Arg_NuiFusionShadePointCloud(long pPointCloudFrame, Struct_Matrix4 pWorldToCameraTransform,
				Struct_Matrix4 pWorldToBGRTransform, long pShadedSurfaceFrame,
				long pShadedSurfaceNormalsFrame) {
			this.pPointCloudFrame = pPointCloudFrame;
			this.pWorldToCameraTransform = pWorldToCameraTransform;
			this.pWorldToBGRTransform = pWorldToBGRTransform;
			this.pShadedSurfaceFrame = pShadedSurfaceFrame;
			this.pShadedSurfaceNormalsFrame = pShadedSurfaceNormalsFrame;
		}
	}
	
	int NuiFusionShadePointCloud(long pPointCloudFrame, Struct_Matrix4 pWorldToCameraTransform,
			Struct_Matrix4 pWorldToBGRTransform, long pShadedSurfaceFrame,
			long pShadedSurfaceNormalsFrame) throws Exception_KINECT {
		Arg_NuiFusionShadePointCloud anfspc = new Arg_NuiFusionShadePointCloud(pPointCloudFrame,
				pWorldToCameraTransform, pWorldToBGRTransform, pShadedSurfaceFrame, 
				pShadedSurfaceNormalsFrame);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiFusionShadePointCloud], anfspc);
		
		System.out.println("NuiFusionShadePointCloud rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(anfspc.getLastError()));
		
		if (anfspc.getLastError() < 0) throw new Exception_KINECT("NuiFusionShadePointCloud");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiFusionShadePointCloud");
		
		return intRtn;
	}
	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}

}
