package testkinect;

import utildll.*;

class Wrp_KinectInteraction {
	static final int CHARSET = Arg.UNICODE;
	static final String INTERACTION_DLL_NAME = "KinectInteraction180_64";
	private String[] strFncName = {
			"NuiCreateInteractionStream"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_NuiCreateInteractionStream = 0;
	private long hMod = 0;
	
	Wrp_KinectInteraction() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(INTERACTION_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " strFncName: " + strFncName[i]);
		}
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT NuiCreateInteractionStream(
		INuiSensor *pNuiSensor,
		INuiInteractionClient *pInteractionClient,
		INuiInteractionStream **ppInteractionStream
	)
	 */
	class Arg_NuiCreateInteractionStream extends Arg_property {
		private long pNuiSensor; // INuiSensor *
		private long pInteractionClient; // INuiInteractionClient *
		private long[] ppInteractionStream; // INuiInteractionStream **

		Arg_NuiCreateInteractionStream(long pNuiSensor, long pInteractionClient, long[] ppInteractionStream) {
			this.pNuiSensor = pNuiSensor;
			this.pInteractionClient = pInteractionClient;
			this.ppInteractionStream = ppInteractionStream;
		}
	}
	
	int NuiCreateInteractionStream(long pNuiSensor, long pInteractionClient, long[] ppInteractionStream)
			throws Exception_KINECT {
		Arg_NuiCreateInteractionStream ancis = new Arg_NuiCreateInteractionStream(pNuiSensor,
				pInteractionClient, ppInteractionStream);

		int intRtn = JInvoker.callIntProcAddress(lngFncAdrs[IDX_NuiCreateInteractionStream], ancis);
		
		System.out.println("NuiCreateInteractionStream rtn: " + Integer.toHexString(intRtn)
				+ " LastError: " + Integer.toString(ancis.getLastError()));
		
		if (ancis.getLastError() < 0) throw new Exception_KINECT("NuiCreateInteractionStream");
		if (H_WinError.FAILED(intRtn)) throw new Exception_KINECT("NuiCreateInteractionStream");
		
		return intRtn;
	}

	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}
	
}
